(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('angular-tree-grid', ['exports', '@angular/core', 'rxjs', '@angular/common', '@angular/forms'], factory) :
    (global = global || self, factory(global['angular-tree-grid'] = {}, global.ng.core, global.rxjs, global.ng.common, global.ng.forms));
}(this, (function (exports, core, rxjs, common, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularTreeGridService = /** @class */ (function () {
        function AngularTreeGridService() {
            this.display_data_observable = new rxjs.Subject();
            this.display_data_observable$ = this.display_data_observable.asObservable();
        }
        /**
         * @param {?} display_data
         * @return {?}
         */
        AngularTreeGridService.prototype.updateDisplayDataObservable = /**
         * @param {?} display_data
         * @return {?}
         */
        function (display_data) {
            this.display_data_observable.next(display_data);
        };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.findRowIndex = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        function (display_data, configs, row_id) {
            return display_data.map((/**
             * @param {?} row
             * @return {?}
             */
            function (row) { return row[configs.id_field]; })).
                indexOf(row_id);
        };
        /**
         * @param {?} display_data
         * @return {?}
         */
        AngularTreeGridService.prototype.selectAll = /**
         * @param {?} display_data
         * @return {?}
         */
        function (display_data) {
            display_data.forEach((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                data.row_selected = true;
            }));
        };
        /**
         * @param {?} display_data
         * @return {?}
         */
        AngularTreeGridService.prototype.deSelectAll = /**
         * @param {?} display_data
         * @return {?}
         */
        function (display_data) {
            display_data.forEach((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                data.row_selected = false;
            }));
        };
        /**
         * @param {?} expand_tracker
         * @return {?}
         */
        AngularTreeGridService.prototype.expandAll = /**
         * @param {?} expand_tracker
         * @return {?}
         */
        function (expand_tracker) {
            for (var key in expand_tracker) {
                if (expand_tracker.hasOwnProperty(key)) {
                    expand_tracker[key] = true;
                }
            }
        };
        /**
         * @param {?} expand_tracker
         * @return {?}
         */
        AngularTreeGridService.prototype.collapseAll = /**
         * @param {?} expand_tracker
         * @return {?}
         */
        function (expand_tracker) {
            for (var key in expand_tracker) {
                if (expand_tracker.hasOwnProperty(key)) {
                    expand_tracker[key] = false;
                }
            }
            expand_tracker[''] = true;
        };
        /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} expand_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @param {?} store
         * @return {?}
         */
        AngularTreeGridService.prototype.expandRow = /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} expand_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @param {?} store
         * @return {?}
         */
        function (row_id, expand_tracker, expand_event, suppress_event, configs, display_data, store) {
            if (configs.subgrid) {
                this.expandSubgridRow(row_id, expand_tracker, expand_event, suppress_event, configs, display_data, store);
                return;
            }
            /** @type {?} */
            var row_index = this.findRowIndex(display_data, configs, row_id);
            /** @type {?} */
            var row_data = display_data[row_index];
            /** @type {?} */
            var pathx = row_data.pathx;
            /** @type {?} */
            var parts = pathx.split('.');
            expand_tracker[row_data.pathx] = true;
            /** @type {?} */
            var expanded_count = 1;
            for (var index = 0; index < display_data.length; index++) {
                /** @type {?} */
                var record = display_data[index];
                // Stop when all rows are expanded.
                if (expanded_count >= parts.length) {
                    return;
                }
                // Join paths as we expand.
                /** @type {?} */
                var key = parts.slice(0, expanded_count).join('.');
                // We don't want to expand it's children here.
                if (record.pathx.indexOf(key) !== -1) {
                    expanded_count += 1;
                    expand_tracker[record.pathx] = true;
                    if (!suppress_event) {
                        if (configs.load_children_on_expand) {
                            this.emitExpandRowEvent(expand_tracker, expand_event, store, row_data, configs);
                        }
                        else {
                            expand_event.emit({ event: null, data: row_data });
                        }
                    }
                }
            }
        };
        /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} collapse_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @return {?}
         */
        AngularTreeGridService.prototype.collapseRow = /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} collapse_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @return {?}
         */
        function (row_id, expand_tracker, collapse_event, suppress_event, configs, display_data) {
            /** @type {?} */
            var row_index = this.findRowIndex(display_data, configs, row_id);
            /** @type {?} */
            var row_data = display_data[row_index];
            /** @type {?} */
            var pathx = row_data.pathx;
            expand_tracker[pathx] = false;
            // Collapse children rows as well
            display_data.forEach((/**
             * @param {?} record
             * @return {?}
             */
            function (record) {
                if (record.pathx.indexOf(pathx) !== -1) {
                    expand_tracker[record.pathx] = 0;
                    if (!suppress_event) {
                        collapse_event.emit({ event: null, data: row_data });
                    }
                }
            }));
        };
        /**
         * @param {?} expand_tracker
         * @param {?} expand
         * @param {?} store
         * @param {?} row_data
         * @param {?} configs
         * @return {?}
         */
        AngularTreeGridService.prototype.emitExpandRowEvent = /**
         * @param {?} expand_tracker
         * @param {?} expand
         * @param {?} store
         * @param {?} row_data
         * @param {?} configs
         * @return {?}
         */
        function (expand_tracker, expand, store, row_data, configs) {
            /** @type {?} */
            var promise = new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                expand.emit({
                    data: row_data,
                    resolve: resolve
                });
            }));
            expand_tracker[row_data.pathx] = true;
            store.remove_children(row_data);
            row_data.is_loading = true;
            // Add Child rows to the table.
            promise.then((/**
             * @param {?} child_rows
             * @return {?}
             */
            function (child_rows) {
                row_data.is_loading = false;
                store.remove_children(row_data);
                if (child_rows) {
                    child_rows.map((/**
                     * @param {?} child
                     * @return {?}
                     */
                    function (child) {
                        child.leaf = true;
                        child.levelx = row_data.levelx + 1;
                        child.pathx = row_data.pathx + '.' + child[configs.id_field];
                        child.parent_pathx = row_data.pathx;
                        child[configs.parent_id_field] = row_data[configs.id_field];
                    }));
                    store.add_children(row_data, child_rows);
                }
            })).catch((/**
             * @param {?} err
             * @return {?}
             */
            function (err) { }));
        };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.disableRowSelection = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        function (display_data, configs, row_id) {
            /** @type {?} */
            var row_index = this.findRowIndex(display_data, configs, row_id);
            display_data[row_index].selection_disabled = true;
        };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.enableRowSelection = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        function (display_data, configs, row_id) {
            /** @type {?} */
            var row_index = this.findRowIndex(display_data, configs, row_id);
            display_data[row_index].selection_disabled = false;
        };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.disableRowExpand = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        function (display_data, configs, row_id) {
            /** @type {?} */
            var row_index = this.findRowIndex(display_data, configs, row_id);
            display_data[row_index].expand_disabled = true;
        };
        /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridService.prototype.enableRowExpand = /**
         * @param {?} display_data
         * @param {?} configs
         * @param {?} row_id
         * @return {?}
         */
        function (display_data, configs, row_id) {
            /** @type {?} */
            var row_index = this.findRowIndex(display_data, configs, row_id);
            display_data[row_index].expand_disabled = false;
        };
        /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} expand_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @param {?} store
         * @return {?}
         */
        AngularTreeGridService.prototype.expandSubgridRow = /**
         * @param {?} row_id
         * @param {?} expand_tracker
         * @param {?} expand_event
         * @param {?} suppress_event
         * @param {?} configs
         * @param {?} display_data
         * @param {?} store
         * @return {?}
         */
        function (row_id, expand_tracker, expand_event, suppress_event, configs, display_data, store) {
            /** @type {?} */
            var row_index = this.findRowIndex(display_data, configs, row_id);
            /** @type {?} */
            var row_data = display_data[row_index];
            expand_tracker[row_data.pathx] = true;
            if (!suppress_event) {
                this.emitSubgridExpandRowEvent(expand_tracker, expand_event, store, row_data);
            }
        };
        /**
         * @param {?} expand_tracker
         * @param {?} expand
         * @param {?} store
         * @param {?} row_data
         * @return {?}
         */
        AngularTreeGridService.prototype.emitSubgridExpandRowEvent = /**
         * @param {?} expand_tracker
         * @param {?} expand
         * @param {?} store
         * @param {?} row_data
         * @return {?}
         */
        function (expand_tracker, expand, store, row_data) {
            /** @type {?} */
            var promise = new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                expand.emit({
                    data: row_data,
                    resolve: resolve
                });
            }));
            expand_tracker[row_data.pathx] = true;
            /** @type {?} */
            var blank_row = store.showBlankRow(row_data);
            blank_row.loading_children = true;
            // Add Child rows to the table.
            promise.then((/**
             * @param {?} child_rows
             * @return {?}
             */
            function (child_rows) {
                blank_row.loading_children = false;
                if (child_rows) {
                    child_rows.map((/**
                     * @param {?} child
                     * @return {?}
                     */
                    function (child) {
                        child.leaf = true;
                    }));
                    blank_row.children = child_rows;
                }
                else {
                    // Persist old children. If didn't exist then assign blank array.
                    if (!blank_row.children) {
                        blank_row.children = [];
                    }
                }
            })).catch((/**
             * @param {?} err
             * @return {?}
             */
            function (err) { }));
        };
        AngularTreeGridService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        AngularTreeGridService.ctorParameters = function () { return []; };
        /** @nocollapse */ AngularTreeGridService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function AngularTreeGridService_Factory() { return new AngularTreeGridService(); }, token: AngularTreeGridService, providedIn: "root" });
        return AngularTreeGridService;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AngularTreeGridService.prototype.display_data_observable;
        /** @type {?} */
        AngularTreeGridService.prototype.display_data_observable$;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Store = /** @class */ (function () {
        function Store(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
        }
        /**
         * @return {?}
         */
        Store.prototype.getRawData = /**
         * @return {?}
         */
        function () {
            return this.raw_data;
        };
        /**
         * @param {?} raw_data
         * @return {?}
         */
        Store.prototype.setRawData = /**
         * @param {?} raw_data
         * @return {?}
         */
        function (raw_data) {
            this.raw_data = raw_data;
        };
        /**
         * @return {?}
         */
        Store.prototype.getProcessedData = /**
         * @return {?}
         */
        function () {
            return this.processed_data;
        };
        /**
         * @param {?} processed_data
         * @return {?}
         */
        Store.prototype.setProcessedData = /**
         * @param {?} processed_data
         * @return {?}
         */
        function (processed_data) {
            this.processed_data = processed_data;
            this.setDisplayData(__spread(processed_data));
        };
        /**
         * @return {?}
         */
        Store.prototype.getDisplayData = /**
         * @return {?}
         */
        function () {
            return this.display_data;
        };
        /**
         * @param {?} display_data
         * @return {?}
         */
        Store.prototype.setDisplayData = /**
         * @param {?} display_data
         * @return {?}
         */
        function (display_data) {
            this.display_data = display_data;
            this.angularTreeGridService.updateDisplayDataObservable(this.display_data);
        };
        /**
         * Show Blank row for subgrid.
         *
         * @param  row_data Row Data
         * @returns blank_row
         */
        /**
         * Show Blank row for subgrid.
         *
         * @param {?} row_data Row Data
         * @return {?} blank_row
         */
        Store.prototype.showBlankRow = /**
         * Show Blank row for subgrid.
         *
         * @param {?} row_data Row Data
         * @return {?} blank_row
         */
        function (row_data) {
            var _this = this;
            /** @type {?} */
            var row_index = this.display_data.map((/**
             * @param {?} row
             * @return {?}
             */
            function (row) { return row[_this.configs.id_field]; })).
                indexOf(row_data[this.configs.id_field]);
            /** @type {?} */
            var blank_row = this.display_data[row_index + 1];
            if (!blank_row || blank_row.parent_pathx !== row_data[this.configs.id_field]) {
                blank_row = {
                    leaf: true,
                    row_selected: true,
                    // By default make it selected as it's never going to be selected manually.
                    parent_pathx: row_data[this.configs.id_field]
                };
                blank_row[this.configs.id_field] = -1;
                this.display_data.splice(row_index + 1, 0, blank_row);
            }
            return blank_row;
        };
        /**
         * @param {?} row_data
         * @return {?}
         */
        Store.prototype.remove_children = /**
         * @param {?} row_data
         * @return {?}
         */
        function (row_data) {
            /** @type {?} */
            var new_processed_data = [];
            for (var index = 0; index < this.processed_data.length; index++) {
                /** @type {?} */
                var element = this.processed_data[index];
                if (element[this.configs.parent_id_field] !== row_data[this.configs.id_field]) {
                    new_processed_data.push(element);
                }
            }
            this.setProcessedData(new_processed_data);
        };
        /**
         * @param {?} row_data
         * @param {?} children
         * @return {?}
         */
        Store.prototype.add_children = /**
         * @param {?} row_data
         * @param {?} children
         * @return {?}
         */
        function (row_data, children) {
            var _this = this;
            /** @type {?} */
            var row_index = this.processed_data.map((/**
             * @param {?} row
             * @return {?}
             */
            function (row) { return row[_this.configs.id_field]; })).
                indexOf(row_data[this.configs.id_field]);
            /** @type {?} */
            var top_rows = this.processed_data.slice(0, row_index + 1);
            /** @type {?} */
            var bottom_rows = this.processed_data.slice(row_index + 1);
            this.processed_data = top_rows.concat(children).concat(bottom_rows);
            this.setDisplayData(__spread(this.processed_data));
            this.angularTreeGridService.updateDisplayDataObservable(this.display_data);
        };
        /**
         * @param {?} columns
         * @param {?} search_values
         * @return {?}
         */
        Store.prototype.filterBy = /**
         * @param {?} columns
         * @param {?} search_values
         * @return {?}
         */
        function (columns, search_values) {
            this.display_data = this.processed_data.filter((/**
             * @param {?} record
             * @return {?}
             */
            function (record) {
                /** @type {?} */
                var found = true;
                for (var index = 0; index < columns.length; index++) {
                    /** @type {?} */
                    var column = columns[index];
                    /** @type {?} */
                    var column_value = record[column.name];
                    /** @type {?} */
                    var search_value = search_values[index];
                    // If blank then continue.
                    if (!search_value) {
                        continue;
                    }
                    // Call custom filter function.
                    if (column.filter_function) {
                        /** @type {?} */
                        var response = column.filter_function(record, column, column_value, search_value);
                        if (response === false) {
                            found = false;
                        }
                    }
                    else {
                        if (typeof (column_value) === 'number') {
                            if (column_value !== parseInt(search_value, 10)) {
                                found = false;
                            }
                        }
                        else {
                            if (!column.case_sensitive_filter) {
                                column_value = column_value.toLowerCase();
                                search_value = search_value.toLowerCase();
                            }
                            if (column_value.indexOf(search_value) === -1) {
                                found = false;
                            }
                        }
                    }
                }
                return found;
            }));
            this.angularTreeGridService.updateDisplayDataObservable(this.display_data);
        };
        /**
         * @param {?} data
         * @param {?} configs
         * @return {?}
         */
        Store.prototype.findTopParentNode = /**
         * @param {?} data
         * @param {?} configs
         * @return {?}
         */
        function (data, configs) {
            /** @type {?} */
            var ids = data.map((/**
             * @param {?} element
             * @return {?}
             */
            function (element) { return element[configs.id_field]; }));
            /** @type {?} */
            var top_parents = [];
            // Find parents ie if parent_id is not present in ids.
            data.forEach((/**
             * @param {?} element
             * @return {?}
             */
            function (element) {
                if (ids.indexOf(element[configs.parent_id_field]) === -1) {
                    top_parents.push(element[configs.parent_id_field]);
                }
            }));
            // Remove duplicates
            top_parents = top_parents.filter((/**
             * @param {?} item
             * @param {?} pos
             * @param {?} self
             * @return {?}
             */
            function (item, pos, self) {
                return self.indexOf(item) === pos;
            }));
            return top_parents;
        };
        /**
         * @param {?} data
         * @param {?} expand_tracker
         * @param {?} configs
         * @param {?} edit_tracker
         * @param {?} internal_configs
         * @return {?}
         */
        Store.prototype.processData = /**
         * @param {?} data
         * @param {?} expand_tracker
         * @param {?} configs
         * @param {?} edit_tracker
         * @param {?} internal_configs
         * @return {?}
         */
        function (data, expand_tracker, configs, edit_tracker, internal_configs) {
            var _this = this;
            /** @type {?} */
            var top_parents = this.findTopParentNode(data, configs);
            /** @type {?} */
            var processed_data = [];
            internal_configs.top_parents = top_parents;
            data.map((/**
             * @param {?} rec
             * @return {?}
             */
            function (rec) {
                rec.pathx = [];
                rec.leaf = false;
            }));
            top_parents.forEach((/**
             * @param {?} top_parent
             * @return {?}
             */
            function (top_parent) {
                /** @type {?} */
                var children = _this.findChildren(data, top_parent, configs);
                _this.orderData(data, processed_data, configs, children, [], 0);
            }));
            processed_data.map((/**
             * @param {?} rec
             * @return {?}
             */
            function (rec) {
                /** @type {?} */
                var parent_pathx = rec.parent_pathx;
                rec.parent_pathx = parent_pathx.join('.');
                parent_pathx.push(rec[configs.id_field]);
                // Add current id to create current path.
                rec.pathx = parent_pathx.join('.');
                expand_tracker[rec.pathx] = false;
                edit_tracker[rec[configs.id_field]] = false;
                // For Subgrid feature, expect all rows are expandable.
                if (configs.subgrid) {
                    rec.leaf = false;
                }
            }));
            // Expand root.
            expand_tracker[''] = true;
            this.setProcessedData(processed_data);
            this.setRawData(data);
            this.configs = configs;
        };
        /**
         * @param {?} data
         * @param {?} id
         * @param {?} configs
         * @return {?}
         */
        Store.prototype.findChildren = /**
         * @param {?} data
         * @param {?} id
         * @param {?} configs
         * @return {?}
         */
        function (data, id, configs) {
            return data.filter((/**
             * @param {?} rec
             * @return {?}
             */
            function (rec) { return rec[configs.parent_id_field] === id; }));
        };
        /**
         * @param {?} data
         * @param {?} processed_data
         * @param {?} configs
         * @param {?} parents
         * @param {?} paths
         * @param {?} levelx
         * @return {?}
         */
        Store.prototype.orderData = /**
         * @param {?} data
         * @param {?} processed_data
         * @param {?} configs
         * @param {?} parents
         * @param {?} paths
         * @param {?} levelx
         * @return {?}
         */
        function (data, processed_data, configs, parents, paths, levelx) {
            var _this = this;
            parents.forEach((/**
             * @param {?} parent
             * @return {?}
             */
            function (parent) {
                /** @type {?} */
                var children = _this.findChildren(data, parent[configs.id_field], configs);
                if (children.length === 0) {
                    parent.leaf = true;
                    parent.levelx = levelx;
                    parent.parent_pathx = __spread(paths);
                    processed_data.push(parent);
                }
                else {
                    parent.parent_pathx = __spread(paths);
                    parent.levelx = levelx;
                    processed_data.push(parent);
                    /** @type {?} */
                    var newPaths = __spread(paths, [parent[configs.id_field]]);
                    _this.orderData(data, processed_data, configs, children, newPaths, levelx + 1);
                }
            }));
        };
        /**
         * @return {?}
         */
        Store.prototype.refreshDisplayData = /**
         * @return {?}
         */
        function () {
            this.display_data = this.processed_data;
            this.angularTreeGridService.updateDisplayDataObservable(this.display_data);
        };
        return Store;
    }());
    if (false) {
        /** @type {?} */
        Store.prototype.processed_data;
        /** @type {?} */
        Store.prototype.raw_data;
        /** @type {?} */
        Store.prototype.display_data;
        /** @type {?} */
        Store.prototype.configs;
        /**
         * @type {?}
         * @private
         */
        Store.prototype.angularTreeGridService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularTreeGridComponent = /** @class */ (function () {
        function AngularTreeGridComponent(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
            this.processed_data = [];
            this.expand_tracker = {};
            this.columns = [];
            this.edit_tracker = {}; // Track Edit options.
            // Track Edit options.
            this.internal_configs = {
                show_add_row: false,
                show_parent_col: false,
                all_selected: false
            };
            this.store = new Store(this.angularTreeGridService);
            this.default_configs = {
                css: {
                    expand_class: 'plus',
                    collapse_class: 'minus',
                    add_class: 'plus',
                    edit_class: '',
                    delete_class: '',
                    save_class: '',
                    cancel_class: '',
                    row_selection_class: 'selected',
                    header_class: '',
                    row_filter_class: '',
                    table_class: ''
                },
                actions: {
                    edit: false,
                    add: false,
                    delete: false,
                    resolve_edit: false,
                    resolve_add: false,
                    resolve_delete: false,
                    edit_parent: false
                },
                data_loading_text: 'Loading...',
                filter: false,
                multi_select: false,
                show_parent_on_edit: true,
                show_summary_row: false,
                subgrid: false,
                load_children_on_expand: false,
                action_column_width: '60px',
                row_class_function: (/**
                 * @return {?}
                 */
                function () { return true; }),
                row_edit_function: (/**
                 * @return {?}
                 */
                function () { return true; }),
                row_delete_function: (/**
                 * @return {?}
                 */
                function () { return true; }),
                subgrid_config: {
                    show_summary_row: false,
                    data_loading_text: 'Loading...'
                }
            };
            this.default_column_config = {
                sorted: 0,
                sort_type: null,
                editable: false,
                hidden: false,
                filter: true,
                case_sensitive_filter: false
            };
            this.cellclick = new core.EventEmitter();
            this.expand = new core.EventEmitter();
            this.collapse = new core.EventEmitter();
            this.rowselect = new core.EventEmitter();
            this.rowdeselect = new core.EventEmitter();
            this.rowselectall = new core.EventEmitter();
            this.rowdeselectall = new core.EventEmitter();
            this.rowadd = new core.EventEmitter();
            this.rowsave = new core.EventEmitter();
            this.rowdelete = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (!this.validateConfigs()) {
                return;
            }
            this.setDefaultConfigs();
            this.setColumnNames();
        };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
        function () {
            if (!this.validateConfigs()) {
                return;
            }
            this.setDefaultConfigs();
            this.setColumnNames();
            this.store.processData(this.data, this.expand_tracker, this.configs, this.edit_tracker, this.internal_configs);
        };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.validateConfigs = /**
         * @return {?}
         */
        function () {
            if (!this.data) {
                window.console.warn('data can\'t be empty!');
                return;
            }
            if (!this.configs) {
                window.console.warn('configs can\'t be empty!');
                return;
            }
            /** @type {?} */
            var element = this.data[0];
            /** @type {?} */
            var isValidated = true;
            if (!this.configs.id_field) {
                isValidated = false;
                window.console.error('id field is mandatory!');
            }
            if (!this.configs.parent_id_field && !this.configs.subgrid) {
                isValidated = false;
                window.console.error('parent_id field is mandatory!');
            }
            if (element && !element.hasOwnProperty(this.configs.id_field)) {
                isValidated = false;
                console.error('id_field doesn\'t exist!');
            }
            if (element && !element.hasOwnProperty(this.configs.parent_id_field)
                && !this.configs.subgrid
                && !this.configs.load_children_on_expand) {
                isValidated = false;
                console.error('parent_id_field doesn\'t exist!');
            }
            if (element && !element.hasOwnProperty(this.configs.parent_display_field)) {
                isValidated = false;
                console.error('parent_display_field doesn\'t exist! Basically this field will be expanded.');
            }
            if (this.configs.subgrid && !this.configs.subgrid_config) {
                isValidated = false;
                console.error('subgrid_config doesn\'t exist!');
            }
            if (this.configs.subgrid && this.configs.subgrid_config && !this.configs.subgrid_config.id_field) {
                isValidated = false;
                console.error('id_field of subgrid doesn\'t exist!');
            }
            if (this.configs.subgrid && this.configs.subgrid_config && !this.configs.subgrid_config.columns) {
                isValidated = false;
                console.error('columns of subgrid doesn\'t exist!');
            }
            return isValidated;
        };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.setDefaultConfigs = /**
         * @return {?}
         */
        function () {
            this.processed_data = [];
            this.configs = Object.assign({}, this.default_configs, this.configs);
            // Deep clone.
            this.configs.actions = Object.assign({}, this.default_configs.actions, this.configs.actions);
            this.configs.css = Object.assign({}, this.default_configs.css, this.configs.css);
            this.configs.subgrid_config = Object.assign({}, this.default_configs.subgrid_config, this.configs.subgrid_config);
            if (this.configs.subgrid) {
                this.configs.actions.add = false;
            }
        };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.setColumnNames = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.columns = this.configs.columns ? this.configs.columns : [];
            // If columns doesn't exist in user's object.
            if (!this.configs.columns) {
                /** @type {?} */
                var column_keys = Object.keys(this.data[0]);
                // Insert Header and default configuration.
                column_keys.forEach((/**
                 * @param {?} key
                 * @return {?}
                 */
                function (key) {
                    _this.columns.push(Object.assign({ 'header': key, 'name': key }, _this.default_column_config));
                }));
            }
            else {
                // Insert Header and default configuration.
                for (var i = 0; i < this.columns.length; i++) {
                    this.columns[i] = Object.assign({}, this.default_column_config, this.columns[i]);
                }
            }
        };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.collapseAll = /**
         * @return {?}
         */
        function () {
            this.angularTreeGridService.collapseAll(this.expand_tracker);
        };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.expandAll = /**
         * @return {?}
         */
        function () {
            this.angularTreeGridService.expandAll(this.expand_tracker);
        };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.selectAll = /**
         * @return {?}
         */
        function () {
            this.angularTreeGridService.selectAll(this.store.getDisplayData());
            this.internal_configs.all_selected = true;
        };
        /**
         * @return {?}
         */
        AngularTreeGridComponent.prototype.deSelectAll = /**
         * @return {?}
         */
        function () {
            this.angularTreeGridService.deSelectAll(this.store.getDisplayData());
            this.internal_configs.all_selected = false;
        };
        /**
         * @param {?} row_id
         * @param {?=} suppress_event
         * @return {?}
         */
        AngularTreeGridComponent.prototype.expandRow = /**
         * @param {?} row_id
         * @param {?=} suppress_event
         * @return {?}
         */
        function (row_id, suppress_event) {
            this.angularTreeGridService.expandRow(row_id, this.expand_tracker, this.expand, suppress_event, this.configs, this.store.getDisplayData(), this.store);
        };
        /**
         * @param {?} row_id
         * @param {?=} suppress_event
         * @return {?}
         */
        AngularTreeGridComponent.prototype.collapseRow = /**
         * @param {?} row_id
         * @param {?=} suppress_event
         * @return {?}
         */
        function (row_id, suppress_event) {
            this.angularTreeGridService.collapseRow(row_id, this.expand_tracker, this.collapse, suppress_event, this.configs, this.store.getDisplayData());
        };
        /**
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridComponent.prototype.disableRowSelection = /**
         * @param {?} row_id
         * @return {?}
         */
        function (row_id) {
            this.angularTreeGridService.disableRowSelection(this.store.getDisplayData(), this.configs, row_id);
        };
        /**
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridComponent.prototype.enableRowSelection = /**
         * @param {?} row_id
         * @return {?}
         */
        function (row_id) {
            this.angularTreeGridService.enableRowSelection(this.store.getDisplayData(), this.configs, row_id);
        };
        /**
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridComponent.prototype.disableRowExpand = /**
         * @param {?} row_id
         * @return {?}
         */
        function (row_id) {
            this.angularTreeGridService.disableRowExpand(this.store.getDisplayData(), this.configs, row_id);
        };
        /**
         * @param {?} row_id
         * @return {?}
         */
        AngularTreeGridComponent.prototype.enableRowExpand = /**
         * @param {?} row_id
         * @return {?}
         */
        function (row_id) {
            this.angularTreeGridService.enableRowExpand(this.store.getDisplayData(), this.configs, row_id);
        };
        AngularTreeGridComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'db-angular-tree-grid',
                        template: "<table [attr.class]=\"'db-tree-view ' + configs.css.table_class\" >\r\n    <thead \r\n        db-tree-head\r\n        [store]=\"store\"\r\n        [expand_tracker]=\"expand_tracker\"\r\n        [internal_configs]=\"internal_configs\"\r\n        [edit_tracker]=\"edit_tracker\"\r\n        [rowselectall]=\"rowselectall\"\r\n        [rowdeselectall]=\"rowdeselectall\"\r\n        [columns]=\"columns\"\r\n        [configs]=\"configs\">\r\n    </thead>\r\n\r\n    <tbody \r\n        db-tree-body\r\n        [store]=\"store\"\r\n        [expand_tracker]=\"expand_tracker\"\r\n        [edit_tracker]=\"edit_tracker\"\r\n        [internal_configs]=\"internal_configs\"\r\n        [columns]=\"columns\"\r\n        [configs]=\"configs\"\r\n        [cellclick]=\"cellclick\"\r\n        [expand]=\"expand\"\r\n        [collapse]=\"collapse\"\r\n        [rowdelete]=\"rowdelete\"\r\n        [rowsave]=\"rowsave\"\r\n        [rowadd]=\"rowadd\"\r\n        [rowselect]=\"rowselect\"\r\n        [rowdeselect]=\"rowdeselect\"\r\n    >        \r\n    </tbody>\r\n</table>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}"]
                    }] }
        ];
        /** @nocollapse */
        AngularTreeGridComponent.ctorParameters = function () { return [
            { type: AngularTreeGridService }
        ]; };
        AngularTreeGridComponent.propDecorators = {
            data: [{ type: core.Input }],
            configs: [{ type: core.Input }],
            cellclick: [{ type: core.Output }],
            expand: [{ type: core.Output }],
            collapse: [{ type: core.Output }],
            rowselect: [{ type: core.Output }],
            rowdeselect: [{ type: core.Output }],
            rowselectall: [{ type: core.Output }],
            rowdeselectall: [{ type: core.Output }],
            rowadd: [{ type: core.Output }],
            rowsave: [{ type: core.Output }],
            rowdelete: [{ type: core.Output }]
        };
        return AngularTreeGridComponent;
    }());
    if (false) {
        /** @type {?} */
        AngularTreeGridComponent.prototype.processed_data;
        /** @type {?} */
        AngularTreeGridComponent.prototype.expand_tracker;
        /** @type {?} */
        AngularTreeGridComponent.prototype.columns;
        /** @type {?} */
        AngularTreeGridComponent.prototype.edit_tracker;
        /** @type {?} */
        AngularTreeGridComponent.prototype.internal_configs;
        /** @type {?} */
        AngularTreeGridComponent.prototype.store;
        /** @type {?} */
        AngularTreeGridComponent.prototype.data;
        /** @type {?} */
        AngularTreeGridComponent.prototype.configs;
        /** @type {?} */
        AngularTreeGridComponent.prototype.default_configs;
        /** @type {?} */
        AngularTreeGridComponent.prototype.default_column_config;
        /** @type {?} */
        AngularTreeGridComponent.prototype.cellclick;
        /** @type {?} */
        AngularTreeGridComponent.prototype.expand;
        /** @type {?} */
        AngularTreeGridComponent.prototype.collapse;
        /** @type {?} */
        AngularTreeGridComponent.prototype.rowselect;
        /** @type {?} */
        AngularTreeGridComponent.prototype.rowdeselect;
        /** @type {?} */
        AngularTreeGridComponent.prototype.rowselectall;
        /** @type {?} */
        AngularTreeGridComponent.prototype.rowdeselectall;
        /** @type {?} */
        AngularTreeGridComponent.prototype.rowadd;
        /** @type {?} */
        AngularTreeGridComponent.prototype.rowsave;
        /** @type {?} */
        AngularTreeGridComponent.prototype.rowdelete;
        /**
         * @type {?}
         * @private
         */
        AngularTreeGridComponent.prototype.angularTreeGridService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeBodyComponent = /** @class */ (function () {
        function TreeBodyComponent(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
            this.parents = [];
        }
        /**
         * @return {?}
         */
        TreeBodyComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.display_data = this.store.getDisplayData();
            this.angularTreeGridService.display_data_observable$.subscribe((/**
             * @param {?} store
             * @return {?}
             */
            function (store) {
                _this.display_data = _this.store.getDisplayData();
                _this.setParents();
            }));
            this.setParents();
        };
        /**
         * @return {?}
         */
        TreeBodyComponent.prototype.setParents = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.parents = this.store.raw_data.map((/**
             * @param {?} element
             * @return {?}
             */
            function (element) {
                return {
                    'id': element[_this.configs.id_field],
                    'value': element[_this.configs.parent_display_field]
                };
            }));
        };
        /**
         * @param {?} element
         * @return {?}
         */
        TreeBodyComponent.prototype.refreshData = /**
         * @param {?} element
         * @return {?}
         */
        function (element) {
            // If edit parent is not true then don't refresh.
            if (!this.configs.actions.edit_parent) {
                return;
            }
            element[this.configs.parent_id_field] = parseInt(element[this.configs.parent_id_field], 10);
            this.expand_tracker = {};
            this.edit_tracker = {};
            this.store.processData(this.store.getRawData(), this.expand_tracker, this.configs, this.edit_tracker, this.internal_configs);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.onRowExpand = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            /** @type {?} */
            var row_data = event.data;
            if (!this.configs.load_children_on_expand) {
                this.expand_tracker[row_data.pathx] = true;
                this.expand.emit(event);
            }
            else {
                this.angularTreeGridService.emitExpandRowEvent(this.expand_tracker, this.expand, this.store, row_data, this.configs);
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.onRowCollapse = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            var _this = this;
            /** @type {?} */
            var row_data = event.data;
            this.expand_tracker[row_data.pathx] = false;
            // Collapse all of its children.
            /** @type {?} */
            var keys = Object.keys(this.expand_tracker);
            keys.forEach((/**
             * @param {?} key
             * @return {?}
             */
            function (key) {
                if (key.indexOf(row_data.pathx) !== -1) {
                    _this.expand_tracker[key] = 0;
                }
            }));
            this.collapse.emit(event);
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeBodyComponent.prototype.saveRecord = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            var _this = this;
            /** @type {?} */
            var element = $event.data;
            if (this.configs.actions.resolve_edit) {
                /** @type {?} */
                var promise = new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                function (resolve, reject) {
                    _this.rowsave.emit({
                        data: element,
                        resolve: resolve
                    });
                }));
                promise.then((/**
                 * @return {?}
                 */
                function () {
                    _this.checkAndRefreshData(element);
                })).catch((/**
                 * @param {?} err
                 * @return {?}
                 */
                function (err) { }));
            }
            else {
                this.checkAndRefreshData(element);
                this.rowsave.emit(element);
            }
        };
        /**
         * @param {?} element
         * @return {?}
         */
        TreeBodyComponent.prototype.checkAndRefreshData = /**
         * @param {?} element
         * @return {?}
         */
        function (element) {
            this.edit_tracker[element[this.configs.id_field]] = false;
            this.internal_configs.show_parent_col = false;
            // Only refresh if Parent has been changed.
            if (this.internal_configs.current_edited_row[this.configs.parent_id_field]
                !== element[this.configs.parent_id_field]) {
                this.refreshData(element);
            }
        };
        /**
         * @param {?} element
         * @return {?}
         */
        TreeBodyComponent.prototype.addRow = /**
         * @param {?} element
         * @return {?}
         */
        function (element) {
            var _this = this;
            if (this.configs.actions.resolve_add) {
                /** @type {?} */
                var promise = new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                function (resolve, reject) {
                    _this.rowadd.emit({
                        data: element,
                        resolve: resolve
                    });
                }));
                promise.then((/**
                 * @return {?}
                 */
                function () {
                    _this.internal_configs.show_add_row = false;
                    _this.refreshData(element);
                })).catch((/**
                 * @param {?} err
                 * @return {?}
                 */
                function (err) { }));
            }
            else {
                this.refreshData(element);
                this.internal_configs.show_add_row = false;
                this.rowadd.emit(element);
            }
        };
        /**
         * @param {?} row_data
         * @return {?}
         */
        TreeBodyComponent.prototype.cancelEdit = /**
         * @param {?} row_data
         * @return {?}
         */
        function (row_data) {
            /** @type {?} */
            var index = row_data[this.configs.id_field];
            // Cancel all changes ie copy from back up.
            Object.assign(row_data, this.internal_configs.current_edited_row);
            this.edit_tracker[index] = false;
            this.internal_configs.show_parent_col = false;
        };
        /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.selectRow = /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        function (row_data, event) {
            // Don't run if Multi select is enabled.
            if (this.configs.multi_select) {
                return;
            }
            this.store.getDisplayData().forEach((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                data.row_selected = false;
            }));
            row_data.row_selected = true;
            this.rowselect.emit({ data: row_data, event: event });
        };
        /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        TreeBodyComponent.prototype.selectRowOnCheck = /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        function (row_data, event) {
            if (event.target.checked) {
                row_data.row_selected = true;
                this.rowselect.emit({ data: row_data, event: event });
            }
            else {
                row_data.row_selected = false;
                this.rowdeselect.emit({ data: row_data, event: event });
            }
            this.setSelectAllConfig();
        };
        /**
         * Set Select All config on Select change.
         *
         */
        /**
         * Set Select All config on Select change.
         *
         * @return {?}
         */
        TreeBodyComponent.prototype.setSelectAllConfig = /**
         * Set Select All config on Select change.
         *
         * @return {?}
         */
        function () {
            /** @type {?} */
            var select_all = true;
            this.store.getDisplayData().forEach((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                if (!data.row_selected) {
                    select_all = false;
                }
            }));
            this.internal_configs.all_selected = select_all;
        };
        TreeBodyComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[db-tree-body]',
                        template: "<ng-container *ngIf=\"configs\">\r\n<tr *ngIf=\"store.raw_data.length==0\">\r\n  <td [innerHTML]=\"configs.data_loading_text\" [attr.colspan]=\"columns.length + 1\" style=\"text-align: center\"></td>\r\n</tr>\r\n<tr db-filter-row \r\n  [columns]=\"columns\" \r\n  [configs]=\"configs\"\r\n  [store]=\"store\"\r\n  [internal_configs]=\"internal_configs\" \r\n  *ngIf=\"configs.filter\"\r\n  [expand_tracker]=\"expand_tracker\"\r\n  [ngClass]=\"configs.css.row_filter_class\">\r\n</tr>\r\n<tr db-add-row \r\n  [columns]=\"columns\" \r\n  [configs]=\"configs\" \r\n  [internal_configs]=\"internal_configs\" \r\n  [store]=\"store\"\r\n  (rowadd)=\"addRow($event)\"\r\n  *ngIf=\"internal_configs.show_add_row\"\r\n  class=\"{{configs.row_class_function()}}\">\r\n</tr>\r\n<ng-container *ngIf=\"configs.subgrid\">\r\n  <tr db-subgrid\r\n  *ngFor=\"let row_data of display_data\"\r\n  class=\"subgrid-row\"\r\n  [configs]=\"configs\" \r\n  [internal_configs]=\"internal_configs\" \r\n  [expand_tracker]=\"expand_tracker\" \r\n  [edit_tracker]=\"edit_tracker\" \r\n  [store]=\"store\"\r\n  [row_data]=\"row_data\"\r\n  [cellclick]=\"cellclick\"\r\n  [rowselect]=\"rowselect\"\r\n  [rowdeselect]=\"rowdeselect\"\r\n  [expand]=\"expand\"\r\n  [rowsave]=\"rowsave\"\r\n  [rowdelete]=\"rowdelete\"\r\n  >\r\n\r\n  </tr>\r\n</ng-container>\r\n<ng-container *ngIf=\"!configs.subgrid\">\r\n  <tr \r\n  *ngFor=\"let row_data of display_data\"\r\n  [attr.class]=\"configs.row_class_function(row_data) + ' ' + (row_data.row_selected ? configs.css.row_selection_class : '')\"\r\n  (click)=\"selectRow(row_data, $event)\" \r\n  >  \r\n  <ng-container *ngIf=\"expand_tracker[row_data.parent_pathx]\">\r\n    <td *ngIf=\"configs.multi_select\" class=\"checkbox_column\">\r\n      <input type=\"checkbox\" [checked]=\"row_data.row_selected\" (click)=\"selectRowOnCheck(row_data, $event)\" \r\n        [attr.disabled]=\"row_data.selection_disabled\">\r\n    </td>\r\n    <td db-tree-cell-actions \r\n      *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add)\"\r\n      [row_data]=\"row_data\"\r\n      [configs]=\"configs\"\r\n      [store]=\"store\"\r\n      [edit_tracker]=\"edit_tracker\"\r\n      [internal_configs]=\"internal_configs\"\r\n      [rowdelete]=\"rowdelete\"\r\n      (canceledit)=\"cancelEdit($event)\" \r\n      (editcomplete)=\"saveRecord($event)\">\r\n    </td>\r\n    <td *ngFor=\"let column of columns; index as i\" \r\n    class=\"{{column.css_class}}\"\r\n    [ngClass]=\"{'column-hide': column.hidden, 'expand-column': i == 0}\">\r\n      <db-tree-cell\r\n        [configs]=\"configs\"\r\n        [column]=\"column\"\r\n        [index]=\"i\"\r\n        [row_data]=\"row_data\"\r\n        [expand_tracker]=\"expand_tracker\"\r\n        [edit_on]=\"edit_tracker[row_data[configs.id_field]]\"\r\n        [cellclick]=\"cellclick\"\r\n        (rowexpand)=\"onRowExpand($event)\"\r\n        (rowcollapse)=\"onRowCollapse($event)\"\r\n        (editcomplete)=\"saveRecord($event)\"\r\n      >\r\n      </db-tree-cell>\r\n    </td>\r\n    <td *ngIf=\"configs.show_parent_on_edit && internal_configs.show_parent_col\">\r\n      <select *ngIf=\"edit_tracker[row_data[configs.id_field]]\" \r\n        [(ngModel)]=\"row_data[configs.parent_id_field]\">\r\n        <option *ngFor=\"let parent of parents\" [value]=\"parent.id\">{{parent.value}}</option>\r\n      </select>\r\n    </td>    \r\n\r\n    <!-- Add column to fix UI issue when add row is enabled but don't show when edit is enabled for the row -->\r\n    <td *ngIf=\"internal_configs.show_add_row && !(internal_configs.show_parent_col && configs.show_parent_on_edit)\"></td>\r\n  </ng-container>\r\n</tr>\r\n<tr *ngIf=\"configs.show_summary_row\">\r\n  <td *ngIf=\"configs.multi_select\"></td>\r\n  <td *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add)\"></td>\r\n  <td *ngFor=\"let column of configs.columns\">\r\n    <div [innerHTML]=\"column.summary_renderer && column.summary_renderer(display_data)\"></div>\r\n  </td>\r\n</tr>\r\n</ng-container>\r\n\r\n</ng-container>\r\n",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr.subgrid-row{background:#fcfcfc}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}tr td.checkbox_column{text-align:center}tr td.expand-column{padding:.3rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}"]
                    }] }
        ];
        /** @nocollapse */
        TreeBodyComponent.ctorParameters = function () { return [
            { type: AngularTreeGridService }
        ]; };
        TreeBodyComponent.propDecorators = {
            store: [{ type: core.Input }],
            configs: [{ type: core.Input }],
            expand_tracker: [{ type: core.Input }],
            edit_tracker: [{ type: core.Input }],
            internal_configs: [{ type: core.Input }],
            columns: [{ type: core.Input }],
            cellclick: [{ type: core.Input }],
            expand: [{ type: core.Input }],
            collapse: [{ type: core.Input }],
            rowdelete: [{ type: core.Input }],
            rowsave: [{ type: core.Input }],
            rowadd: [{ type: core.Input }],
            rowselect: [{ type: core.Input }],
            rowdeselect: [{ type: core.Input }]
        };
        return TreeBodyComponent;
    }());
    if (false) {
        /** @type {?} */
        TreeBodyComponent.prototype.parents;
        /** @type {?} */
        TreeBodyComponent.prototype.raw_data;
        /** @type {?} */
        TreeBodyComponent.prototype.display_data;
        /** @type {?} */
        TreeBodyComponent.prototype.store;
        /** @type {?} */
        TreeBodyComponent.prototype.configs;
        /** @type {?} */
        TreeBodyComponent.prototype.expand_tracker;
        /** @type {?} */
        TreeBodyComponent.prototype.edit_tracker;
        /** @type {?} */
        TreeBodyComponent.prototype.internal_configs;
        /** @type {?} */
        TreeBodyComponent.prototype.columns;
        /** @type {?} */
        TreeBodyComponent.prototype.cellclick;
        /** @type {?} */
        TreeBodyComponent.prototype.expand;
        /** @type {?} */
        TreeBodyComponent.prototype.collapse;
        /** @type {?} */
        TreeBodyComponent.prototype.rowdelete;
        /** @type {?} */
        TreeBodyComponent.prototype.rowsave;
        /** @type {?} */
        TreeBodyComponent.prototype.rowadd;
        /** @type {?} */
        TreeBodyComponent.prototype.rowselect;
        /** @type {?} */
        TreeBodyComponent.prototype.rowdeselect;
        /**
         * @type {?}
         * @private
         */
        TreeBodyComponent.prototype.angularTreeGridService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellComponent = /** @class */ (function () {
        function TreeCellComponent() {
            this.rowexpand = new core.EventEmitter();
            this.rowcollapse = new core.EventEmitter();
            this.canceledit = new core.EventEmitter();
            this.editcomplete = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeCellComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.is_expand_column = this.index === 0;
            this.show_expand_icon = !this.row_data.leaf;
            // If user mentions a node as leaf.
            if (this.configs.load_children_on_expand) {
                this.show_expand_icon = !this.row_data.leaf_node;
            }
            this.cell_value = this.row_data[this.column.name];
        };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeCellComponent.prototype.expandRow = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (this.index === 0 && (!this.row_data.leaf || this.configs.load_children_on_expand)) {
                this.rowexpand.emit({ event: event, data: this.row_data });
                event.stopPropagation();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeCellComponent.prototype.collapseRow = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (this.index === 0 && (!this.row_data.leaf || this.configs.load_children_on_expand)) {
                this.rowcollapse.emit({ event: event, data: this.row_data });
                event.stopPropagation();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        TreeCellComponent.prototype.onCellClick = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.cellclick.emit({ column: this.column, row: this.row_data, event: event });
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeCellComponent.prototype.onEditComplete = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            this.editcomplete.emit({ event: $event, data: this.row_data });
        };
        TreeCellComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'db-tree-cell',
                        template: "<div (click)=\"onCellClick($event)\">\r\n  <ng-container *ngIf=\"is_expand_column\">\r\n    <div [ngStyle]=\"{'padding-left': row_data.leaf ? row_data.levelx * 20 + 'px' : row_data.levelx * 10 + 'px'}\">\r\n      <ng-container *ngIf=\"!expand_tracker[row_data.pathx]\">\r\n        <span (click)=\"expandRow($event)\">\r\n          <i \r\n            [ngClass]=\"configs.css.expand_class\" \r\n            class=\"expand-icon\" \r\n            aria-hidden=\"true\"\r\n            [ngStyle]=\"{'visibility': row_data.expand_disabled ? 'hidden' : 'visible'}\"\r\n            *ngIf=\"show_expand_icon\"\r\n          ></i>\r\n        </span>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"expand_tracker[row_data.pathx]\">\r\n        <span *ngIf=\"row_data.is_loading\" class=\"childred-loader\"></span>\r\n        <span (click)=\"collapseRow($event)\" *ngIf=\"!row_data.is_loading\">\r\n          <i \r\n            [ngClass]=\"configs.css.collapse_class\" \r\n            class=\"expand-icon\" \r\n            aria-hidden=\"true\"\r\n            [ngStyle]=\"{'visibility': row_data.expand_disabled ? 'hidden' : 'visible'}\"            \r\n            *ngIf=\"show_expand_icon\"\r\n          ></i>\r\n        </span>          \r\n      </ng-container>      \r\n      <ng-container *ngIf=\"!edit_on || !column.editable\" [ngSwitch]=\"column.type\">\r\n        <db-custom-cell-component \r\n          *ngSwitchCase=\"'custom'\"\r\n          [column]=\"column\" \r\n          [row_data]=\"row_data\">\r\n        </db-custom-cell-component>\r\n        <db-tree-cell-view\r\n          *ngSwitchDefault \r\n          [column] = \"column\"\r\n          [row_data] = \"row_data\">\r\n        </db-tree-cell-view>\r\n      </ng-container>\r\n      <ng-container *ngIf=\"edit_on && column.editable\">\r\n          <db-custom-cell-editor-component \r\n            *ngIf=\"column.editor\" \r\n            [cell_value]=\"cell_value\" \r\n            [column]=\"column\" \r\n            [row_data]=\"row_data\"\r\n            (canceledit)=\"canceledit.emit(row_data['pathx'])\"\r\n            (editcomplete)=\"onEditComplete($event)\">\r\n        </db-custom-cell-editor-component>\r\n        <db-tree-cell-editor \r\n            *ngIf=\"!column.editor\"\r\n            [cell_value]=\"cell_value\" \r\n            [row_data]=\"row_data\" \r\n            [column]=\"column\"\r\n            [expandable_column]=true\r\n            (canceledit)=\"canceledit.emit(row_data['pathx'])\"\r\n            (editcomplete)=\"onEditComplete($event)\"\r\n            >\r\n        </db-tree-cell-editor>\r\n      </ng-container>\r\n    </div>\r\n  </ng-container>\r\n  <ng-container *ngIf=\"!is_expand_column\">\r\n    <ng-container *ngIf=\"!edit_on || !column.editable\" [ngSwitch]=\"column.type\">\r\n      <db-custom-cell-component \r\n        *ngSwitchCase=\"'custom'\"\r\n        [column]=\"column\" \r\n        [row_data]=\"row_data\">\r\n      </db-custom-cell-component>\r\n      <db-tree-cell-view\r\n        *ngSwitchDefault \r\n        [column] = \"column\"\r\n        [row_data] = \"row_data\">\r\n      </db-tree-cell-view>\r\n    </ng-container> \r\n\r\n    <ng-container *ngIf=\"edit_on && column.editable\">\r\n        <db-custom-cell-editor-component \r\n          *ngIf=\"column.editor\" \r\n          [cell_value]=\"cell_value\" \r\n          [column]=\"column\" \r\n          [row_data]=\"row_data\"\r\n          (canceledit)=\"canceledit.emit(row_data['pathx'])\"\r\n          (editcomplete)=\"onEditComplete($event)\">\r\n      </db-custom-cell-editor-component>\r\n      <db-tree-cell-editor \r\n          *ngIf=\"!column.editor\"\r\n          [cell_value]=\"cell_value\" \r\n          [row_data]=\"row_data\" \r\n          [column]=\"column\"\r\n          [expandable_column]=false\r\n          (canceledit)=\"canceledit.emit(row_data['pathx'])\"\r\n          (editcomplete)=\"onEditComplete($event)\"\r\n          >\r\n      </db-tree-cell-editor>\r\n    </ng-container> \r\n  </ng-container>\r\n</div>\r\n",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}i.expand-icon{margin-right:8px}i.plus{border:1px solid transparent;margin-right:32px}i.plus:before{content:\"\";width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}i.plus:after{content:\"\";width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}i.minus{border:1px solid transparent;margin-right:32px}i.minus:before{content:\"\";width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}span.childred-loader{border:3px solid #f3f3f3;-webkit-animation:1s linear infinite spin;animation:1s linear infinite spin;border-top:3px solid #555;border-radius:50%;width:10px;height:10px;display:inline-block;margin-right:5px}@-webkit-keyframes spin{0%{-webkit-transform:rotate(0);transform:rotate(0)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}@keyframes spin{0%{-webkit-transform:rotate(0);transform:rotate(0)}100%{-webkit-transform:rotate(360deg);transform:rotate(360deg)}}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellComponent.ctorParameters = function () { return []; };
        TreeCellComponent.propDecorators = {
            configs: [{ type: core.Input }],
            index: [{ type: core.Input }],
            row_data: [{ type: core.Input }],
            column: [{ type: core.Input }],
            expand_tracker: [{ type: core.Input }],
            cellclick: [{ type: core.Input }],
            edit_on: [{ type: core.Input }],
            rowexpand: [{ type: core.Output }],
            rowcollapse: [{ type: core.Output }],
            canceledit: [{ type: core.Output }],
            editcomplete: [{ type: core.Output }]
        };
        return TreeCellComponent;
    }());
    if (false) {
        /** @type {?} */
        TreeCellComponent.prototype.is_expand_column;
        /** @type {?} */
        TreeCellComponent.prototype.show_expand_icon;
        /** @type {?} */
        TreeCellComponent.prototype.cell_value;
        /** @type {?} */
        TreeCellComponent.prototype.configs;
        /** @type {?} */
        TreeCellComponent.prototype.index;
        /** @type {?} */
        TreeCellComponent.prototype.row_data;
        /** @type {?} */
        TreeCellComponent.prototype.column;
        /** @type {?} */
        TreeCellComponent.prototype.expand_tracker;
        /** @type {?} */
        TreeCellComponent.prototype.cellclick;
        /** @type {?} */
        TreeCellComponent.prototype.edit_on;
        /** @type {?} */
        TreeCellComponent.prototype.rowexpand;
        /** @type {?} */
        TreeCellComponent.prototype.rowcollapse;
        /** @type {?} */
        TreeCellComponent.prototype.canceledit;
        /** @type {?} */
        TreeCellComponent.prototype.editcomplete;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellViewComponent = /** @class */ (function () {
        function TreeCellViewComponent() {
        }
        /**
         * @return {?}
         */
        TreeCellViewComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        TreeCellViewComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'db-tree-cell-view',
                        template: "<span [innerHTML]=\"column.renderer ? column.renderer(row_data[column.name], row_data) : row_data[column.name]\"></span>\r\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        TreeCellViewComponent.ctorParameters = function () { return []; };
        TreeCellViewComponent.propDecorators = {
            column: [{ type: core.Input }],
            row_data: [{ type: core.Input }]
        };
        return TreeCellViewComponent;
    }());
    if (false) {
        /** @type {?} */
        TreeCellViewComponent.prototype.column;
        /** @type {?} */
        TreeCellViewComponent.prototype.row_data;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomCellViewComponent = /** @class */ (function () {
        function CustomCellViewComponent(resolver) {
            this.resolver = resolver;
        }
        /**
         * @return {?}
         */
        CustomCellViewComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (this.column.component && !this.custom_component) {
                this.createCustomComponent();
                this.callOnComponentInit();
            }
        };
        /**
         * @return {?}
         */
        CustomCellViewComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this.custom_component) {
                this.custom_component.destroy();
            }
        };
        /**
         * @protected
         * @return {?}
         */
        CustomCellViewComponent.prototype.createCustomComponent = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var componentFactory = this.resolver.resolveComponentFactory(this.column.component);
            this.custom_component = this.custom_view.createComponent(componentFactory);
        };
        /**
         * @protected
         * @return {?}
         */
        CustomCellViewComponent.prototype.callOnComponentInit = /**
         * @protected
         * @return {?}
         */
        function () {
            this.column.on_component_init && this.column.on_component_init(this.custom_component.instance);
            this.custom_component.instance.cell_value = this.row_data[this.column.name];
            this.custom_component.instance.row_data = this.row_data;
            this.custom_component.instance.column = this.column;
        };
        CustomCellViewComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'db-custom-cell-component',
                        template: "\n      <ng-template #customView></ng-template>\n    "
                    }] }
        ];
        /** @nocollapse */
        CustomCellViewComponent.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver }
        ]; };
        CustomCellViewComponent.propDecorators = {
            column: [{ type: core.Input }],
            row_data: [{ type: core.Input }],
            custom_view: [{ type: core.ViewChild, args: ['customView', { read: core.ViewContainerRef, static: true },] }]
        };
        return CustomCellViewComponent;
    }());
    if (false) {
        /** @type {?} */
        CustomCellViewComponent.prototype.custom_component;
        /** @type {?} */
        CustomCellViewComponent.prototype.column;
        /** @type {?} */
        CustomCellViewComponent.prototype.row_data;
        /** @type {?} */
        CustomCellViewComponent.prototype.custom_view;
        /**
         * @type {?}
         * @private
         */
        CustomCellViewComponent.prototype.resolver;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellActionsComponent = /** @class */ (function () {
        function TreeCellActionsComponent() {
            this.editcomplete = new core.EventEmitter();
            this.canceledit = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        TreeCellActionsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.display_data = this.store.getDisplayData();
        };
        /**
         * @param {?} index
         * @param {?} row_data
         * @return {?}
         */
        TreeCellActionsComponent.prototype.enableEdit = /**
         * @param {?} index
         * @param {?} row_data
         * @return {?}
         */
        function (index, row_data) {
            this.edit_tracker[index] = true;
            // Only if edit_parent is true.
            if (this.configs.actions.edit_parent) {
                this.internal_configs.show_parent_col = true;
                this.internal_configs.current_edited_row = __assign({}, row_data);
            }
        };
        /**
         * @param {?} pathx
         * @return {?}
         */
        TreeCellActionsComponent.prototype.findRecordIndex = /**
         * @param {?} pathx
         * @return {?}
         */
        function (pathx) {
            for (var index in this.store.processed_data) {
                if (this.store.processed_data[index].pathx === pathx) {
                    return Number(index);
                }
            }
        };
        /**
         * @param {?} rec
         * @return {?}
         */
        TreeCellActionsComponent.prototype.deleteRecord = /**
         * @param {?} rec
         * @return {?}
         */
        function (rec) {
            var _this = this;
            /** @type {?} */
            var index = this.findRecordIndex(rec.pathx);
            if (this.configs.actions.resolve_delete) {
                /** @type {?} */
                var promise = new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                function (resolve, reject) {
                    _this.rowdelete.emit({
                        data: rec,
                        resolve: resolve
                    });
                }));
                promise.then((/**
                 * @return {?}
                 */
                function () {
                    _this.store.processed_data.splice(index, 1);
                    _this.store.refreshDisplayData();
                })).catch((/**
                 * @param {?} err
                 * @return {?}
                 */
                function (err) { }));
            }
            else {
                this.store.processed_data.splice(index, 1);
                this.store.refreshDisplayData();
                this.rowdelete.emit(rec);
            }
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        TreeCellActionsComponent.prototype.saveRecord = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            this.editcomplete.emit({ event: $event, data: this.row_data });
        };
        TreeCellActionsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[db-tree-cell-actions]',
                        template: "<ng-container *ngIf=\"configs.actions.edit && configs.row_edit_function(row_data)\">\r\n  <div *ngIf=\"!edit_tracker[row_data[configs.id_field]]\" class=\"icon-container\">\r\n    <i (click)=\"enableEdit(row_data[configs.id_field], row_data)\" *ngIf=\"configs.css.edit_class\" title=\"Edit row\" class=\"{{this.configs.css.edit_class}}\" aria-hidden=\"true\" ></i>\r\n    <svg (click)=\"enableEdit(row_data[configs.id_field], row_data)\" *ngIf=\"!configs.css.edit_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Edit row</title><g data-name=\"Layer 2\"><g data-name=\"edit\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M19.4 7.34L16.66 4.6A2 2 0 0 0 14 4.53l-9 9a2 2 0 0 0-.57 1.21L4 18.91a1 1 0 0 0 .29.8A1 1 0 0 0 5 20h.09l4.17-.38a2 2 0 0 0 1.21-.57l9-9a1.92 1.92 0 0 0-.07-2.71zM9.08 17.62l-3 .28.27-3L12 9.32l2.7 2.7zM16 10.68L13.32 8l1.95-2L18 8.73z\"/></g></g></svg>             \r\n  </div>\r\n  <ng-container *ngIf=\"edit_tracker[row_data[configs.id_field]]\">\r\n    <div class=\"icon-container\">\r\n      <i (click)=\"saveRecord($event)\" *ngIf=\"configs.css.save_class\" title=\"Save row\" class=\"{{this.configs.css.save_class}}\" aria-hidden=\"true\"></i>\r\n      <svg (click)=\"saveRecord($event)\" title=\"Save row\" *ngIf=\"!configs.css.save_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Save row</title><g data-name=\"Layer 2\"><g data-name=\"save\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M20.12 8.71l-4.83-4.83A3 3 0 0 0 13.17 3H6a3 3 0 0 0-3 3v12a3 3 0 0 0 3 3h12a3 3 0 0 0 3-3v-7.17a3 3 0 0 0-.88-2.12zM10 19v-2h4v2zm9-1a1 1 0 0 1-1 1h-2v-3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3H6a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h2v5a1 1 0 0 0 1 1h4a1 1 0 0 0 0-2h-3V5h3.17a1.05 1.05 0 0 1 .71.29l4.83 4.83a1 1 0 0 1 .29.71z\"/></g></g></svg>\r\n    </div>\r\n    <div class=\"icon-container\">\r\n      <i (click)=\"canceledit.emit(row_data)\" *ngIf=\"configs.css.cancel_class\" title=\"Cancel row\" class=\"{{this.configs.css.cancel_class}}\" aria-hidden=\"true\"></i>\r\n      <svg (click)=\"canceledit.emit(row_data)\" *ngIf=\"!configs.css.cancel_class\" title=\"Cancel row\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Cancel row</title><g data-name=\"Layer 2\"><g data-name=\"close\"><rect width=\"24\" height=\"24\" transform=\"rotate(180 12 12)\" opacity=\"0\"/><path d=\"M13.41 12l4.3-4.29a1 1 0 1 0-1.42-1.42L12 10.59l-4.29-4.3a1 1 0 0 0-1.42 1.42l4.3 4.29-4.3 4.29a1 1 0 0 0 0 1.42 1 1 0 0 0 1.42 0l4.29-4.3 4.29 4.3a1 1 0 0 0 1.42 0 1 1 0 0 0 0-1.42z\"/></g></g></svg>\r\n    </div>\r\n  </ng-container>\r\n</ng-container>            \r\n<div \r\n  class=\"icon-container\"\r\n  *ngIf=\"\r\n      configs.actions.delete && \r\n      !edit_tracker[row_data[configs.id_field]] && \r\n      configs.row_delete_function(row_data)\">\r\n  <i *ngIf=\"configs.css.delete_class\" title=\"Delete row\" (click)=\"deleteRecord(row_data)\" class=\"{{this.configs.css.delete_class}}\" aria-hidden=\"true\"></i>\r\n  <svg *ngIf=\"!configs.css.delete_class\" title=\"Delete row\" (click)=\"deleteRecord(row_data)\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Delete row</title><g data-name=\"Layer 2\"><g data-name=\"trash-2\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M21 6h-5V4.33A2.42 2.42 0 0 0 13.5 2h-3A2.42 2.42 0 0 0 8 4.33V6H3a1 1 0 0 0 0 2h1v11a3 3 0 0 0 3 3h10a3 3 0 0 0 3-3V8h1a1 1 0 0 0 0-2zM10 4.33c0-.16.21-.33.5-.33h3c.29 0 .5.17.5.33V6h-4zM18 19a1 1 0 0 1-1 1H7a1 1 0 0 1-1-1V8h12z\"/><path d=\"M9 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z\"/><path d=\"M15 17a1 1 0 0 0 1-1v-4a1 1 0 0 0-2 0v4a1 1 0 0 0 1 1z\"/></g></g></svg>            \r\n</div>",
                        styles: ["svg{width:25px;padding-right:5px}div.icon-container{display:inline-block;width:50%;text-align:center;color:#000;cursor:pointer}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellActionsComponent.ctorParameters = function () { return []; };
        TreeCellActionsComponent.propDecorators = {
            store: [{ type: core.Input }],
            edit_tracker: [{ type: core.Input }],
            internal_configs: [{ type: core.Input }],
            configs: [{ type: core.Input }],
            rowdelete: [{ type: core.Input }],
            row_data: [{ type: core.Input }],
            editcomplete: [{ type: core.Output }],
            canceledit: [{ type: core.Output }]
        };
        return TreeCellActionsComponent;
    }());
    if (false) {
        /** @type {?} */
        TreeCellActionsComponent.prototype.display_data;
        /** @type {?} */
        TreeCellActionsComponent.prototype.store;
        /** @type {?} */
        TreeCellActionsComponent.prototype.edit_tracker;
        /** @type {?} */
        TreeCellActionsComponent.prototype.internal_configs;
        /** @type {?} */
        TreeCellActionsComponent.prototype.configs;
        /** @type {?} */
        TreeCellActionsComponent.prototype.rowdelete;
        /** @type {?} */
        TreeCellActionsComponent.prototype.row_data;
        /** @type {?} */
        TreeCellActionsComponent.prototype.editcomplete;
        /** @type {?} */
        TreeCellActionsComponent.prototype.canceledit;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DefaultEditor = /** @class */ (function () {
        function DefaultEditor() {
            this.canceledit = new core.EventEmitter();
            this.editcomplete = new core.EventEmitter();
            this.cellclick = new core.EventEmitter();
        }
        DefaultEditor.propDecorators = {
            canceledit: [{ type: core.Output }],
            editcomplete: [{ type: core.Output }],
            cellclick: [{ type: core.Output }]
        };
        return DefaultEditor;
    }());
    if (false) {
        /** @type {?} */
        DefaultEditor.prototype.canceledit;
        /** @type {?} */
        DefaultEditor.prototype.editcomplete;
        /** @type {?} */
        DefaultEditor.prototype.cellclick;
    }
    /**
     * @record
     */
    function Editor() { }
    if (false) {
        /** @type {?} */
        Editor.prototype.canceledit;
        /** @type {?} */
        Editor.prototype.editcomplete;
        /** @type {?} */
        Editor.prototype.cellclick;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CustomCellEditorComponent = /** @class */ (function (_super) {
        __extends(CustomCellEditorComponent, _super);
        function CustomCellEditorComponent(resolver) {
            var _this = _super.call(this) || this;
            _this.resolver = resolver;
            return _this;
        }
        /**
         * @return {?}
         */
        CustomCellEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            if (this.column.editor && !this.custom_component) {
                this.createCustomComponent();
                this.callOnComponentInit();
            }
        };
        /**
         * @return {?}
         */
        CustomCellEditorComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this.custom_component) {
                this.custom_component.destroy();
            }
        };
        /**
         * @protected
         * @return {?}
         */
        CustomCellEditorComponent.prototype.createCustomComponent = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var componentFactory = this.resolver.resolveComponentFactory(this.column.editor);
            this.custom_component = this.custom_view.createComponent(componentFactory);
        };
        /**
         * @protected
         * @return {?}
         */
        CustomCellEditorComponent.prototype.callOnComponentInit = /**
         * @protected
         * @return {?}
         */
        function () {
            var _this = this;
            this.column.on_component_init && this.column.on_component_init(this.custom_component.instance);
            this.custom_component.instance.cell_value = this.cell_value;
            this.custom_component.instance.row_data = this.row_data;
            this.custom_component.instance.column = this.column;
            this.custom_component.instance.editcomplete.subscribe((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return _this.editcomplete.emit(event); }));
            this.custom_component.instance.canceledit.subscribe((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return _this.canceledit.emit(event); }));
            this.custom_component.instance.cellclick.subscribe((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return _this.cellclick.emit(event); }));
        };
        CustomCellEditorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'db-custom-cell-editor-component',
                        template: "\n      <ng-template #customView></ng-template>\n    "
                    }] }
        ];
        /** @nocollapse */
        CustomCellEditorComponent.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver }
        ]; };
        CustomCellEditorComponent.propDecorators = {
            column: [{ type: core.Input }],
            cell_value: [{ type: core.Input }],
            row_data: [{ type: core.Input }],
            custom_view: [{ type: core.ViewChild, args: ['customView', { read: core.ViewContainerRef, static: true },] }]
        };
        return CustomCellEditorComponent;
    }(DefaultEditor));
    if (false) {
        /** @type {?} */
        CustomCellEditorComponent.prototype.custom_component;
        /** @type {?} */
        CustomCellEditorComponent.prototype.column;
        /** @type {?} */
        CustomCellEditorComponent.prototype.cell_value;
        /** @type {?} */
        CustomCellEditorComponent.prototype.row_data;
        /** @type {?} */
        CustomCellEditorComponent.prototype.custom_view;
        /**
         * @type {?}
         * @private
         */
        CustomCellEditorComponent.prototype.resolver;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellEditorComponent = /** @class */ (function (_super) {
        __extends(TreeCellEditorComponent, _super);
        function TreeCellEditorComponent() {
            return _super.call(this) || this;
        }
        /**
         * @return {?}
         */
        TreeCellEditorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        TreeCellEditorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'db-tree-cell-editor',
                        template: "<input type=\"text\" \r\n    [(ngModel)]=\"row_data[column.name]\" \r\n    [ngClass]=\"{'cell-default': true, 'expandable-editor': expandable_column}\"\r\n    (click)=\"cellclick.emit($event)\"\r\n    (keydown.enter)=\"editcomplete.emit($event)\"\r\n    (keydown.esc)=\"canceledit.emit()\"\r\n    size=\"1\"\r\n    >",
                        styles: ["input.cell-default{padding:5px;box-sizing:border-box;width:100%}input.expandable-editor{width:calc(100% - 18px)}"]
                    }] }
        ];
        /** @nocollapse */
        TreeCellEditorComponent.ctorParameters = function () { return []; };
        TreeCellEditorComponent.propDecorators = {
            cell_value: [{ type: core.Input }],
            row_data: [{ type: core.Input }],
            column: [{ type: core.Input }],
            expandable_column: [{ type: core.Input }]
        };
        return TreeCellEditorComponent;
    }(DefaultEditor));
    if (false) {
        /** @type {?} */
        TreeCellEditorComponent.prototype.cell_value;
        /** @type {?} */
        TreeCellEditorComponent.prototype.row_data;
        /** @type {?} */
        TreeCellEditorComponent.prototype.column;
        /** @type {?} */
        TreeCellEditorComponent.prototype.expandable_column;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeCellModule = /** @class */ (function () {
        function TreeCellModule() {
        }
        TreeCellModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            TreeCellComponent,
                            TreeCellViewComponent,
                            CustomCellViewComponent,
                            TreeCellActionsComponent,
                            CustomCellEditorComponent,
                            TreeCellEditorComponent
                        ],
                        imports: [
                            common.CommonModule,
                            forms.FormsModule
                        ],
                        exports: [
                            TreeCellComponent,
                            CustomCellViewComponent,
                            CustomCellEditorComponent,
                            TreeCellEditorComponent,
                            TreeCellActionsComponent
                        ],
                        providers: [AngularTreeGridService]
                    },] }
        ];
        return TreeCellModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AddRowComponent = /** @class */ (function () {
        function AddRowComponent() {
            this.row_data = {};
            this.parents = [];
            this.rowadd = new core.EventEmitter();
            this.canceledit = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        AddRowComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.raw_data = this.store.getRawData();
            this.columns.forEach((/**
             * @param {?} column
             * @return {?}
             */
            function (column) {
                _this.row_data[column.name] = '';
            }));
            this.parents = this.raw_data.map((/**
             * @param {?} element
             * @return {?}
             */
            function (element) {
                return {
                    'id': element[_this.configs.id_field],
                    'value': element[_this.configs.parent_display_field]
                };
            }));
        };
        /**
         * @param {?} e
         * @return {?}
         */
        AddRowComponent.prototype.saveAddRecord = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            this.raw_data.push(this.row_data);
            this.rowadd.emit(this.row_data);
        };
        /**
         * @return {?}
         */
        AddRowComponent.prototype.cancelAddEdit = /**
         * @return {?}
         */
        function () {
            this.internal_configs.show_add_row = false;
        };
        AddRowComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[db-add-row]',
                        template: "<td *ngIf=\"configs.multi_select\"></td>\r\n<td>\r\n  <div class=\"icon-container\">\r\n    <i (click)=\"saveAddRecord($event)\" *ngIf=\"configs.css.save_class\" title=\"Save row\" class=\"{{this.configs.css.save_class}}\" aria-hidden=\"true\"></i>\r\n    <svg (click)=\"saveAddRecord($event)\" title=\"Save row\" *ngIf=\"!configs.css.save_class\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Save row</title><g data-name=\"Layer 2\"><g data-name=\"save\"><rect width=\"24\" height=\"24\" opacity=\"0\"/><path d=\"M20.12 8.71l-4.83-4.83A3 3 0 0 0 13.17 3H6a3 3 0 0 0-3 3v12a3 3 0 0 0 3 3h12a3 3 0 0 0 3-3v-7.17a3 3 0 0 0-.88-2.12zM10 19v-2h4v2zm9-1a1 1 0 0 1-1 1h-2v-3a1 1 0 0 0-1-1H9a1 1 0 0 0-1 1v3H6a1 1 0 0 1-1-1V6a1 1 0 0 1 1-1h2v5a1 1 0 0 0 1 1h4a1 1 0 0 0 0-2h-3V5h3.17a1.05 1.05 0 0 1 .71.29l4.83 4.83a1 1 0 0 1 .29.71z\"/></g></g></svg>\r\n  </div>\r\n  <div class=\"icon-container\">\r\n    <i (click)=\"cancelAddEdit()\" *ngIf=\"configs.css.cancel_class\" title=\"Cancel row\" class=\"{{this.configs.css.cancel_class}}\" aria-hidden=\"true\"></i>\r\n    <svg (click)=\"cancelAddEdit()\" *ngIf=\"!configs.css.cancel_class\" title=\"Cancel row\" xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 24 24\"><title>Cancel row</title><g data-name=\"Layer 2\"><g data-name=\"close\"><rect width=\"24\" height=\"24\" transform=\"rotate(180 12 12)\" opacity=\"0\"/><path d=\"M13.41 12l4.3-4.29a1 1 0 1 0-1.42-1.42L12 10.59l-4.29-4.3a1 1 0 0 0-1.42 1.42l4.3 4.29-4.3 4.29a1 1 0 0 0 0 1.42 1 1 0 0 0 1.42 0l4.29-4.3 4.29 4.3a1 1 0 0 0 1.42 0 1 1 0 0 0 0-1.42z\"/></g></g></svg>\r\n  </div>\r\n</td>\r\n<td *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\" >\r\n  <div *ngIf=\"column.editable\">\r\n    <db-custom-cell-editor-component \r\n        *ngIf=\"column.editor\"\r\n        [cell_value]=\"\" \r\n        [column]=\"column\" \r\n        [row_data]=\"row_data\"\r\n        (canceledit)=\"cancelAddEdit()\"\r\n        (editcomplete)=\"saveAddRecord($event)\">\r\n    </db-custom-cell-editor-component>\r\n    <db-tree-cell-editor \r\n        *ngIf=\"!column.editor\"\r\n        [cell_value]=\"\" \r\n        [row_data]=\"row_data\" \r\n        [column]=\"column\"\r\n        (canceledit)=\"cancelAddEdit()\"\r\n        (editcomplete)=\"saveAddRecord($event)\"\r\n        >\r\n    </db-tree-cell-editor>\r\n  </div>\r\n</td>\r\n<td>\r\n  <select [(ngModel)]=\"row_data[configs.parent_id_field]\">\r\n    <option *ngFor=\"let parent of parents\" [value]=\"parent.id\">{{parent.value}}</option>\r\n  </select>\r\n</td>",
                        encapsulation: core.ViewEncapsulation.None,
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr.subgrid-row{background:#fcfcfc}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}tr td.checkbox_column{text-align:center}tr td.expand-column{padding:.3rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}svg{width:25px;padding-right:4px}div.icon-container{display:inline-block;width:50%;text-align:center}"]
                    }] }
        ];
        /** @nocollapse */
        AddRowComponent.ctorParameters = function () { return []; };
        AddRowComponent.propDecorators = {
            store: [{ type: core.Input }],
            columns: [{ type: core.Input }],
            configs: [{ type: core.Input }],
            internal_configs: [{ type: core.Input }],
            rowadd: [{ type: core.Output }],
            canceledit: [{ type: core.Output }]
        };
        return AddRowComponent;
    }());
    if (false) {
        /** @type {?} */
        AddRowComponent.prototype.raw_data;
        /** @type {?} */
        AddRowComponent.prototype.row_data;
        /** @type {?} */
        AddRowComponent.prototype.parents;
        /** @type {?} */
        AddRowComponent.prototype.show_add_row;
        /** @type {?} */
        AddRowComponent.prototype.store;
        /** @type {?} */
        AddRowComponent.prototype.columns;
        /** @type {?} */
        AddRowComponent.prototype.configs;
        /** @type {?} */
        AddRowComponent.prototype.internal_configs;
        /** @type {?} */
        AddRowComponent.prototype.rowadd;
        /** @type {?} */
        AddRowComponent.prototype.canceledit;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FilterRowComponent = /** @class */ (function () {
        function FilterRowComponent(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
            this.search_values = {};
        }
        /**
         * @return {?}
         */
        FilterRowComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.columns.forEach((/**
             * @param {?} column
             * @return {?}
             */
            function (column) {
                _this.search_values[column.name] = '';
            }));
        };
        /**
         * @return {?}
         */
        FilterRowComponent.prototype.filter = /**
         * @return {?}
         */
        function () {
            this.store.filterBy(this.columns, Object.values(this.search_values));
            // Don't expand for subgrid.
            if (!this.configs.subgrid) {
                this.angularTreeGridService.expandAll(this.expand_tracker);
            }
        };
        FilterRowComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[db-filter-row]',
                        template: "<td *ngIf=\"configs.multi_select\"></td>\r\n<td *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add)\"></td>\r\n<td *ngFor=\"let column of columns\">\r\n  <div *ngIf=\"column.filter\">\r\n    <input type=\"text\" (keyup)=\"filter()\" [(ngModel)]=\"search_values[column.name]\">\r\n  </div>\r\n</td>\r\n<!-- Add column to fix UI issue when add row is enabled or Edit is enabled -->\r\n<td *ngIf=\"internal_configs.show_add_row || (internal_configs.show_parent_col && configs.show_parent_on_edit)\"></td>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr.subgrid-row{background:#fcfcfc}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}tr td.checkbox_column{text-align:center}tr td.expand-column{padding:.3rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.2rem}td input{width:100%;padding:.1rem;box-sizing:border-box;-webkit-box-sizing:border-box;-moz-box-sizing:border-box}"]
                    }] }
        ];
        /** @nocollapse */
        FilterRowComponent.ctorParameters = function () { return [
            { type: AngularTreeGridService }
        ]; };
        FilterRowComponent.propDecorators = {
            store: [{ type: core.Input }],
            columns: [{ type: core.Input }],
            expand_tracker: [{ type: core.Input }],
            configs: [{ type: core.Input }],
            internal_configs: [{ type: core.Input }]
        };
        return FilterRowComponent;
    }());
    if (false) {
        /** @type {?} */
        FilterRowComponent.prototype.search_values;
        /** @type {?} */
        FilterRowComponent.prototype.store;
        /** @type {?} */
        FilterRowComponent.prototype.columns;
        /** @type {?} */
        FilterRowComponent.prototype.expand_tracker;
        /** @type {?} */
        FilterRowComponent.prototype.configs;
        /** @type {?} */
        FilterRowComponent.prototype.internal_configs;
        /**
         * @type {?}
         * @private
         */
        FilterRowComponent.prototype.angularTreeGridService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SubgridComponent = /** @class */ (function () {
        function SubgridComponent() {
        }
        /**
         * @return {?}
         */
        SubgridComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () { };
        /**
         * @param {?} $event
         * @return {?}
         */
        SubgridComponent.prototype.saveRecord = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            var _this = this;
            /** @type {?} */
            var element = $event.data;
            if (this.configs.actions.resolve_edit) {
                /** @type {?} */
                var promise = new Promise((/**
                 * @param {?} resolve
                 * @param {?} reject
                 * @return {?}
                 */
                function (resolve, reject) {
                    _this.rowsave.emit({
                        data: element,
                        resolve: resolve
                    });
                }));
                promise.then((/**
                 * @return {?}
                 */
                function () {
                    _this.checkAndRefreshData(element);
                })).catch((/**
                 * @param {?} err
                 * @return {?}
                 */
                function (err) { }));
            }
            else {
                this.checkAndRefreshData(element);
                this.rowsave.emit(element);
            }
        };
        /**
         * @param {?} element
         * @return {?}
         */
        SubgridComponent.prototype.checkAndRefreshData = /**
         * @param {?} element
         * @return {?}
         */
        function (element) {
            this.edit_tracker[element[this.configs.id_field]] = false;
            this.internal_configs.show_parent_col = false;
            // Only refresh if Parent has been changed.
            if (this.internal_configs.current_edited_row[this.configs.parent_id_field]
                !== element[this.configs.parent_id_field]) {
                this.refreshData(element);
            }
        };
        /**
         * @param {?} element
         * @return {?}
         */
        SubgridComponent.prototype.refreshData = /**
         * @param {?} element
         * @return {?}
         */
        function (element) {
            // If edit parent is not true then don't refresh.
            if (!this.configs.actions.edit_parent) {
                return;
            }
            element[this.configs.parent_id_field] = parseInt(element[this.configs.parent_id_field], 10);
            this.expand_tracker = {};
            this.edit_tracker = {};
            this.store.processData(this.store.getRawData(), this.expand_tracker, this.configs, this.edit_tracker, this.internal_configs);
        };
        /**
         * @param {?} row_data
         * @return {?}
         */
        SubgridComponent.prototype.cancelEdit = /**
         * @param {?} row_data
         * @return {?}
         */
        function (row_data) {
            /** @type {?} */
            var index = row_data[this.configs.id_field];
            // Cancel all changes ie copy from back up.
            Object.assign(row_data, this.internal_configs.current_edited_row);
            this.edit_tracker[index] = false;
            this.internal_configs.show_parent_col = false;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        SubgridComponent.prototype.onRowExpand = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            var _this = this;
            /** @type {?} */
            var row_data = event.data;
            /** @type {?} */
            var promise = new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                _this.expand.emit({
                    data: row_data,
                    resolve: resolve
                });
            }));
            this.expand_tracker[row_data.pathx] = true;
            /** @type {?} */
            var blank_row = this.store.showBlankRow(row_data);
            blank_row.loading_children = true;
            // Add Child rows to the table.
            promise.then((/**
             * @param {?} child_rows
             * @return {?}
             */
            function (child_rows) {
                blank_row.loading_children = false;
                if (child_rows) {
                    child_rows.map((/**
                     * @param {?} child
                     * @return {?}
                     */
                    function (child) {
                        child.leaf = true;
                    }));
                    blank_row.children = child_rows;
                }
                else {
                    // Persist old children. If didn't exist then assign blank array.
                    if (!blank_row.children) {
                        blank_row.children = [];
                    }
                }
            })).catch((/**
             * @param {?} err
             * @return {?}
             */
            function (err) { }));
        };
        /**
         * @param {?} event
         * @return {?}
         */
        SubgridComponent.prototype.onRowCollapse = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            /** @type {?} */
            var row_data = event.data;
            this.expand_tracker[row_data.pathx] = false;
        };
        /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        SubgridComponent.prototype.selectRowOnCheck = /**
         * @param {?} row_data
         * @param {?} event
         * @return {?}
         */
        function (row_data, event) {
            if (event.target.checked) {
                row_data.row_selected = true;
                this.rowselect.emit({ data: row_data, event: event });
            }
            else {
                row_data.row_selected = false;
                this.rowdeselect.emit({ data: row_data, event: event });
            }
            this.setSelectAllConfig();
        };
        /**
         * Set Select All config on Select change.
         *
         */
        /**
         * Set Select All config on Select change.
         *
         * @return {?}
         */
        SubgridComponent.prototype.setSelectAllConfig = /**
         * Set Select All config on Select change.
         *
         * @return {?}
         */
        function () {
            /** @type {?} */
            var select_all = true;
            this.store.getDisplayData().forEach((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                if (!data.row_selected) {
                    select_all = false;
                }
            }));
            this.internal_configs.all_selected = select_all;
        };
        SubgridComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[db-subgrid]',
                        template: "<ng-container *ngIf=\"expand_tracker[row_data.parent_pathx]\">\r\n\r\n  <!-- Expandable Row -->\r\n  <ng-container *ngIf=\"!row_data.leaf\">\r\n    <td *ngIf=\"configs.multi_select\" class=\"checkbox_column\">\r\n      <input type=\"checkbox\" [checked]=\"row_data.row_selected\" (click)=\"selectRowOnCheck(row_data, $event)\" \r\n        [attr.disabled]=\"row_data.selection_disabled\">\r\n    </td>\r\n    <td db-tree-cell-actions \r\n      *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add)\"\r\n      [row_data]=\"row_data\"\r\n      [configs]=\"configs\"\r\n      [store]=\"store\"\r\n      [edit_tracker]=\"edit_tracker\"\r\n      [internal_configs]=\"internal_configs\"\r\n      [rowdelete]=\"rowdelete\"\r\n      (canceledit)=\"cancelEdit($event)\" \r\n      (editcomplete)=\"saveRecord($event)\"\r\n      >\r\n    </td>\r\n    <td *ngFor=\"let column of configs.columns; index as i\" \r\n      [ngClass]=\"{'column-hide': column.hidden, 'expand-column': i == 0}\">\r\n      <db-tree-cell\r\n        [configs]=\"configs\"\r\n        [column]=\"column\"\r\n        [index]=\"i\"\r\n        [row_data]=\"row_data\"\r\n        [expand_tracker]=\"expand_tracker\"\r\n        [edit_on]=\"edit_tracker[row_data[configs.id_field]]\"\r\n        [cellclick]=\"cellclick\"\r\n        (rowexpand)=\"onRowExpand($event)\"\r\n        (rowcollapse)=\"onRowCollapse($event)\"\r\n        (editcomplete)=\"saveRecord($event)\"\r\n      >\r\n      </db-tree-cell>\r\n    </td>\r\n  </ng-container>\r\n\r\n  <!-- Subgrid Rows -->\r\n  <ng-container *ngIf=\"row_data.leaf\">    \r\n    <td *ngIf=\"configs.multi_select\"></td>\r\n    <td *ngIf=\"(configs.actions.edit || configs.actions.delete || configs.actions.add)\"></td>\r\n    <td [attr.colspan]=\"configs.columns.length\" class=\"subgrid-column\">\r\n        <table class=\"subgrid-table\">\r\n          <thead db-subgrid-head\r\n            [row_data]=\"row_data\"\r\n            [configs]=\"configs\">\r\n            \r\n          </thead>\r\n          <tbody db-subgrid-body\r\n            [configs]=\"configs\"\r\n            [expand_tracker]=\"expand_tracker\"\r\n            [cellclick]=\"cellclick\"\r\n            [row_data]=\"row_data\">\r\n          </tbody>            \r\n        </table>\r\n    </td>    \r\n  </ng-container>  \r\n</ng-container>",
                        styles: ["tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr.subgrid-row{background:#fcfcfc}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}tr td.checkbox_column{text-align:center}tr td.expand-column{padding:.3rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}.db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr{background:#fff}tr th{font-size:1rem;font-weight:600;line-height:1.25;color:#181818;border:1px solid #cdd5dc;vertical-align:middle;position:relative;box-sizing:border-box}tr th div{padding:.5rem}tr th.column-hide{display:none}tr th.action-column span.icon-container{cursor:pointer}tr th i.plus{border:1px solid transparent}tr th i.plus:before{content:\"\";width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}tr th i.plus:after{content:\"\";width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}th.clear-left-border{border-left:0!important}th.clear-right-border{border-right:0!important}.column-hide{display:none}svg{width:25px;padding-right:3px}td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}td.checkbox_column{text-align:center}td.expand-column{padding:.3rem}td.subgrid-column{padding:0}td.column-hide{display:none}td.clear-left-border{border-left:0!important}td.clear-right-border{border-right:0!important}td table.subgrid-table{border-collapse:collapse;width:100%}"]
                    }] }
        ];
        /** @nocollapse */
        SubgridComponent.ctorParameters = function () { return []; };
        SubgridComponent.propDecorators = {
            store: [{ type: core.Input }],
            configs: [{ type: core.Input }],
            expand_tracker: [{ type: core.Input }],
            edit_tracker: [{ type: core.Input }],
            internal_configs: [{ type: core.Input }],
            row_data: [{ type: core.Input }],
            cellclick: [{ type: core.Input }],
            expand: [{ type: core.Input }],
            rowselect: [{ type: core.Input }],
            rowdeselect: [{ type: core.Input }],
            rowsave: [{ type: core.Input }],
            rowdelete: [{ type: core.Input }]
        };
        return SubgridComponent;
    }());
    if (false) {
        /** @type {?} */
        SubgridComponent.prototype.store;
        /** @type {?} */
        SubgridComponent.prototype.configs;
        /** @type {?} */
        SubgridComponent.prototype.expand_tracker;
        /** @type {?} */
        SubgridComponent.prototype.edit_tracker;
        /** @type {?} */
        SubgridComponent.prototype.internal_configs;
        /** @type {?} */
        SubgridComponent.prototype.row_data;
        /** @type {?} */
        SubgridComponent.prototype.cellclick;
        /** @type {?} */
        SubgridComponent.prototype.expand;
        /** @type {?} */
        SubgridComponent.prototype.rowselect;
        /** @type {?} */
        SubgridComponent.prototype.rowdeselect;
        /** @type {?} */
        SubgridComponent.prototype.rowsave;
        /** @type {?} */
        SubgridComponent.prototype.rowdelete;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SubgridHeadComponent = /** @class */ (function () {
        function SubgridHeadComponent() {
        }
        /**
         * @return {?}
         */
        SubgridHeadComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @param {?} row_data
         * @param {?} column
         * @return {?}
         */
        SubgridHeadComponent.prototype.sortColumn = /**
         * @param {?} row_data
         * @param {?} column
         * @return {?}
         */
        function (row_data, column) {
            /** @type {?} */
            var sort_by = column.name;
            // If already sorted then reverse.
            column.sort_type = column.sorted ? !column.sort_type : 1;
            column.sorted = 1;
            column.sort_type ? row_data.children.sort((/**
             * @param {?} a
             * @param {?} b
             * @return {?}
             */
            function (a, b) { return (a[sort_by] > b[sort_by]) ? 1 : ((b[sort_by] > a[sort_by]) ? -1 : 0); })) :
                row_data.children.sort((/**
                 * @param {?} a
                 * @param {?} b
                 * @return {?}
                 */
                function (a, b) { return (a[sort_by] < b[sort_by]) ? 1 : ((b[sort_by] < a[sort_by]) ? -1 : 0); }));
        };
        SubgridHeadComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[db-subgrid-head]',
                        template: "<tr>\r\n  <th *ngFor=\"let column of configs.subgrid_config.columns\"\r\n    (click)=\"sortColumn(row_data, column)\" width=\"{{column.width ? column.width : 'auto'}}\"\r\n    [ngClass]=\"{'sorted': column.sorted,'sortable': column.sortable, 'column-hide': column.hidden}\">\r\n    {{column.header}}\r\n    <span *ngIf=\"column.sortable\" [ngClass]=\"column.sorted && column.sort_type == 0?'arrow-down active':'arrow-down'\"></span>\r\n    <span *ngIf=\"column.sortable\" [ngClass]=\"column.sorted && column.sort_type == 1?'arrow-up active':'arrow-up'\"></span>\r\n  </th>\r\n</tr>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr{background:#fff}tr th{font-size:1rem;font-weight:600;line-height:1.25;color:#181818;border:1px solid #cdd5dc;vertical-align:middle;position:relative;box-sizing:border-box}tr th div{padding:.5rem}tr th.column-hide{display:none}tr th.action-column span.icon-container{cursor:pointer}tr th i.plus{border:1px solid transparent}tr th i.plus:before{content:\"\";width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}tr th i.plus:after{content:\"\";width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}th.clear-left-border{border-left:0!important}th.clear-right-border{border-right:0!important}.column-hide{display:none}svg{width:25px;padding-right:3px}th.sortable{cursor:pointer}th.sortable:hover span.arrow-up{border-bottom:6px solid #afafaf}th.sortable:hover span.arrow-down{border-top:6px solid #afafaf}th span.arrow-up{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-bottom:6px solid #ddd;position:relative;top:-18px}th span.arrow-up.active{border-bottom:6px solid #8a8989!important}th span.arrow-down{width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;border-top:6px solid #ddd;position:relative;left:10px;top:17px}th span.arrow-down.active{border-top:6px solid #8a8989!important}"]
                    }] }
        ];
        /** @nocollapse */
        SubgridHeadComponent.ctorParameters = function () { return []; };
        SubgridHeadComponent.propDecorators = {
            configs: [{ type: core.Input }],
            row_data: [{ type: core.Input }]
        };
        return SubgridHeadComponent;
    }());
    if (false) {
        /** @type {?} */
        SubgridHeadComponent.prototype.configs;
        /** @type {?} */
        SubgridHeadComponent.prototype.row_data;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SubgridBodyComponent = /** @class */ (function () {
        function SubgridBodyComponent() {
        }
        /**
         * @return {?}
         */
        SubgridBodyComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        SubgridBodyComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[db-subgrid-body]',
                        template: "<ng-container *ngIf=\"row_data.loading_children\">\r\n  <tr>\r\n    <td [attr.colspan]=\"configs.subgrid_config.columns.length\" \r\n      [innerHTML]=\"configs.subgrid_config.data_loading_text\"\r\n      class=\"subgrid-loading-text\"></td>\r\n  </tr>\r\n</ng-container>\r\n<ng-container *ngIf=\"!row_data.loading_children\">\r\n  <tr *ngFor=\"let child_data of row_data.children\">\r\n    <td *ngFor=\"let column of configs.subgrid_config.columns; index as i\">\r\n      <db-tree-cell\r\n        [configs]=\"configs\"\r\n        [column]=\"column\"\r\n        [index]=\"1\"\r\n        [row_data]=\"child_data\"\r\n        [expand_tracker]=\"expand_tracker\"\r\n        [cellclick]=\"cellclick\"\r\n      ></db-tree-cell>\r\n    </td>\r\n  </tr>\r\n  <tr *ngIf=\"configs.subgrid_config.show_summary_row\">\r\n    <td *ngFor=\"let column of configs.subgrid_config.columns\">\r\n      <div [innerHTML]=\"column.summary_renderer && column.summary_renderer(row_data.children)\"></div>\r\n    </td>\r\n  </tr>\r\n</ng-container>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr.selected{background-color:#e2e7eb}tr span.parent_container{padding-left:45px}tr.child{background:#fff}tr.child td:nth-child(2){padding:.875rem 1.25rem .875rem 2.5rem!important}tr.parent{background:#fafbff}tr.subgrid-row{background:#fcfcfc}tr td{border:1px solid #cdd5dc;vertical-align:middle;position:relative;padding:.5rem;box-sizing:border-box}tr td.checkbox_column{text-align:center}tr td.expand-column{padding:.3rem}tr td.column-hide{display:none}tr td.clear-left-border{border-left:0!important}tr td.clear-right-border{border-right:0!important}td.subgrid-loading-text{text-align:center}"]
                    }] }
        ];
        /** @nocollapse */
        SubgridBodyComponent.ctorParameters = function () { return []; };
        SubgridBodyComponent.propDecorators = {
            configs: [{ type: core.Input }],
            expand_tracker: [{ type: core.Input }],
            row_data: [{ type: core.Input }],
            cellclick: [{ type: core.Input }]
        };
        return SubgridBodyComponent;
    }());
    if (false) {
        /** @type {?} */
        SubgridBodyComponent.prototype.configs;
        /** @type {?} */
        SubgridBodyComponent.prototype.expand_tracker;
        /** @type {?} */
        SubgridBodyComponent.prototype.row_data;
        /** @type {?} */
        SubgridBodyComponent.prototype.cellclick;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SubgridModule = /** @class */ (function () {
        function SubgridModule() {
        }
        SubgridModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [SubgridComponent, SubgridHeadComponent, SubgridBodyComponent],
                        imports: [
                            common.CommonModule,
                            TreeCellModule
                        ],
                        exports: [SubgridComponent]
                    },] }
        ];
        return SubgridModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeBodyModule = /** @class */ (function () {
        function TreeBodyModule() {
        }
        TreeBodyModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [TreeBodyComponent, AddRowComponent, FilterRowComponent],
                        imports: [
                            common.CommonModule,
                            TreeCellModule,
                            forms.FormsModule,
                            SubgridModule
                        ],
                        exports: [TreeBodyComponent],
                        providers: [AngularTreeGridService]
                    },] }
        ];
        return TreeBodyModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeHeadComponent = /** @class */ (function () {
        function TreeHeadComponent(angularTreeGridService) {
            this.angularTreeGridService = angularTreeGridService;
        }
        /**
         * @return {?}
         */
        TreeHeadComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () { };
        /**
         * @return {?}
         */
        TreeHeadComponent.prototype.addRow = /**
         * @return {?}
         */
        function () {
            this.internal_configs.show_add_row = true;
        };
        /**
         * @param {?} e
         * @return {?}
         */
        TreeHeadComponent.prototype.selectAll = /**
         * @param {?} e
         * @return {?}
         */
        function (e) {
            if (e.target.checked) {
                this.angularTreeGridService.selectAll(this.store.getDisplayData());
                this.rowselectall.emit(this.store.getDisplayData());
            }
            else {
                this.angularTreeGridService.deSelectAll(this.store.getDisplayData());
                this.rowdeselectall.emit(e);
            }
        };
        TreeHeadComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[db-tree-head]',
                        template: "<ng-container *ngIf=\"configs\">\r\n<tr [ngClass]=\"configs.css.header_class\">\r\n  <th *ngIf=\"configs.multi_select\" class=\"checkbox_column\">\r\n    <input type=\"checkbox\" (click)=\"selectAll($event)\" [checked]=\"this.internal_configs.all_selected\">\r\n  </th>\r\n  <th \r\n    *ngIf=\"configs.actions.add || configs.actions.edit || configs.actions.delete\" \r\n    class=\"action-column\"\r\n    width=\"{{configs.action_column_width}}\"\r\n    (click)=\"addRow()\">\r\n    <span class=\"icon-container\">\r\n      <i *ngIf=\"!internal_configs.show_add_row && configs.actions.add\" [ngClass]=\"configs.css.add_class\" aria-hidden=\"true\" title=\"Add a row\"></i>\r\n    </span>\r\n    <span *ngIf=\"internal_configs.show_add_row || !configs.actions.add\">Actions</span>\r\n  </th>\r\n  <th *ngFor=\"let column of columns\" [ngClass]=\"{'column-hide': column.hidden}\" [attr.width]=\"column.width\">\r\n    <div [innerHTML]=\"column.header_renderer ? column.header_renderer(column.header) : column.header\"></div>    \r\n  </th>\r\n  <th *ngIf=\"(configs.show_parent_on_edit && internal_configs.show_parent_col) || internal_configs.show_add_row\">\r\n    Parent\r\n  </th>\r\n</tr>\r\n</ng-container>",
                        styles: [".db-tree-view{line-height:1.5em;border-collapse:collapse;border-spacing:0;display:table;max-width:100%;overflow:auto;word-break:normal;word-break:keep-all;border:1px solid gray;color:#4b4b4b}tr{background:#fff}tr th{font-size:1rem;font-weight:600;line-height:1.25;color:#181818;border:1px solid #cdd5dc;vertical-align:middle;position:relative;box-sizing:border-box}tr th div{padding:.5rem}tr th.column-hide{display:none}tr th.action-column span.icon-container{cursor:pointer}tr th i.plus{border:1px solid transparent}tr th i.plus:before{content:\"\";width:18px;height:1px;border-top:2px solid #222;display:block;position:absolute;margin-top:-15px;margin-left:6px}tr th i.plus:after{content:\"\";width:1px;height:18px;border-right:2px solid #222;display:block;position:absolute;margin-top:-23px;margin-left:14px}th.clear-left-border{border-left:0!important}th.clear-right-border{border-right:0!important}.column-hide{display:none}svg{width:25px;padding-right:3px}"]
                    }] }
        ];
        /** @nocollapse */
        TreeHeadComponent.ctorParameters = function () { return [
            { type: AngularTreeGridService }
        ]; };
        TreeHeadComponent.propDecorators = {
            store: [{ type: core.Input }],
            configs: [{ type: core.Input }],
            expand_tracker: [{ type: core.Input }],
            edit_tracker: [{ type: core.Input }],
            internal_configs: [{ type: core.Input }],
            columns: [{ type: core.Input }],
            rowselectall: [{ type: core.Input }],
            rowdeselectall: [{ type: core.Input }]
        };
        return TreeHeadComponent;
    }());
    if (false) {
        /** @type {?} */
        TreeHeadComponent.prototype.store;
        /** @type {?} */
        TreeHeadComponent.prototype.configs;
        /** @type {?} */
        TreeHeadComponent.prototype.expand_tracker;
        /** @type {?} */
        TreeHeadComponent.prototype.edit_tracker;
        /** @type {?} */
        TreeHeadComponent.prototype.internal_configs;
        /** @type {?} */
        TreeHeadComponent.prototype.columns;
        /** @type {?} */
        TreeHeadComponent.prototype.rowselectall;
        /** @type {?} */
        TreeHeadComponent.prototype.rowdeselectall;
        /**
         * @type {?}
         * @private
         */
        TreeHeadComponent.prototype.angularTreeGridService;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeHeadModule = /** @class */ (function () {
        function TreeHeadModule() {
        }
        TreeHeadModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [TreeHeadComponent],
                        imports: [
                            common.CommonModule
                        ],
                        exports: [TreeHeadComponent],
                        providers: [AngularTreeGridService]
                    },] }
        ];
        return TreeHeadModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AngularTreeGridModule = /** @class */ (function () {
        function AngularTreeGridModule() {
        }
        AngularTreeGridModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [AngularTreeGridComponent],
                        imports: [
                            common.CommonModule,
                            TreeBodyModule,
                            TreeHeadModule
                        ],
                        exports: [AngularTreeGridComponent],
                        providers: [AngularTreeGridService]
                    },] }
        ];
        return AngularTreeGridModule;
    }());

    exports.AngularTreeGridComponent = AngularTreeGridComponent;
    exports.AngularTreeGridModule = AngularTreeGridModule;
    exports.AngularTreeGridService = AngularTreeGridService;
    exports.DefaultEditor = DefaultEditor;
    exports.ɵa = TreeBodyModule;
    exports.ɵb = TreeBodyComponent;
    exports.ɵc = AddRowComponent;
    exports.ɵd = FilterRowComponent;
    exports.ɵe = TreeCellModule;
    exports.ɵf = TreeCellComponent;
    exports.ɵg = TreeCellViewComponent;
    exports.ɵh = CustomCellViewComponent;
    exports.ɵi = TreeCellActionsComponent;
    exports.ɵj = CustomCellEditorComponent;
    exports.ɵk = TreeCellEditorComponent;
    exports.ɵl = SubgridModule;
    exports.ɵm = SubgridComponent;
    exports.ɵn = SubgridHeadComponent;
    exports.ɵo = SubgridBodyComponent;
    exports.ɵp = TreeHeadModule;
    exports.ɵq = TreeHeadComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-tree-grid.umd.js.map
